Ultra TC Editors logo

Ultra TC Editors package include the following programs:

  1. Main Menu Editor: for editing Total Commander main menu.
  2. Start Menu Editor: for editing Total Commander start menu.
  3. Directory Menu Editor: for editing Total Commander directory menu.
  4. Extended Commands Editor: for editing Total Commander extended commands.
  5. Button Bar Editor: for editing Total Commander button bar.
  6. History Editor: for editing history sections in Total Commander configuration files (Wincmd.ini and Wcx_ftp.ini)
  7. Configuration Editor: database for all Total Commander configuration keys.
  8. Hotkeys Editor: for modifying Total Commander hotkeys.

Ultra TC Editors screen shoot

Button | Description | Shortcut
editor icon | Runs or activates Main Menu Editor. | M
editor icon | Runs or activates Start Menu Editor. | S and Shift+S
editor icon | Runs or activates Directory Menu Editor. | D and Shift+D
editor icon | Runs or activates Extended Commands Editor. | E and Shift+E
editor icon | Runs or activates Button Bar Editor. | B
editor icon | Runs or activates History Editor. | H
editor icon | Runs or activates Configuration Editor. | C
editor icon | Runs or activates Hotkeys Editor. | K
pin icon | Sets the program window always on top. | A


System requirements

Windows 95/98/ME/NT4/2000/XP/Vista/7

Note: Windows 95 and NT 4.0 users may need an updated comctl32.dll or Microsoft Internet Explorer 4 or higher.

Ultra TC Editors is compiled with Visual Basic 6 and requires the VB6 runtimes to be installed on your computer.

If VB6 runtime files are not installed on your computer, please visit the program Home Page and download the setup program which contain all necessary files to run these programs properly.


License Agreement

Copyright

  • Total Commander is copyright © by Christian Ghisler, Ghisler Software GmbH, PO Box, CH-3065 Bolligen, Switzerland, 1993-2010
  • Ultra TC Editors is copyright © 2004-2011 by Taher Salem, all rights reserved.

Distribution

You are allowed to copy this package and give it to any other person, as long as it is not modified in any way. Under modifications is understood the changing, adding or removing of any files of this package without the author's permission. You are NOT allowed to pack these programs with a commercial program.

Disclaimer of Warranty

THIS SOFTWARE IS PROVIDED "AS IS", NO WARRANTY PROVIDED. THE AUTHOR WILL NOT RESPONSE FOR DATA LOSS, DAMAGES, etc... WHILE USING OR MISUSING THIS SOFTWARE.


Contact Me

Author: Taher Salem (Egypt)

For the latest information on these programs, please visit my Home Page.

For comments, suggestions, asking or report a bug, please mail me.

Thank you very much for trying these tools.

Regards


Main Menu Editor logo

Ultra TC Main Menu Editor is a powerful tool which allows you to edit Total Commander main menu or create a new one.

The program window is divided into three panels:

  • Menu panel: Shows Total Commander main menu in hierarchical display.
  • Category panel: Shows all categories in the Totalcmd.inc file.
  • Command panel: Shows commands under the selected category.

Main Menu Editor screen shoot


File Menu Commands

New

Creates a new Total Commander menu file.

Keyboard shortcut: | Ctrl+N
Toolbar button: | toolbar icon

Open...

Opens an existing Total Commander menu file.

Keyboard shortcut: | Ctrl+O
Toolbar button: | toolbar icon

Save

Saves the current file. When you save a file for the first time, the program will display the Save As dialog box so you can name your menu file.

Keyboard shortcut: | Ctrl+S
Toolbar button: | toolbar icon

Save As...

Saves the current file using a different name.

Save and Restart Total Commander

Saves the current file and restarts Total Commander if it is running, useful to make Total Commander reload the main menu with changes you already did.

Keyboard shortcut: Ctrl+Q

Alert Use this command only if the file you are editing is the current main menu file used by Total Commander, otherwise you will not see your changes when Total Commander restarting.

Create Full Menu

Closes the current file and creates a new file includes all Total Commander internal commands organized according to categories in the Totalcmd.inc file.

To add command text instead of description, before executing this command press Shift key and keep it pressed until finishing.

Check Mnemonics...

Search the current file for duplicated mnemonic or items not containing mnemonics.

Customize Totalcmd.inc file...

Displays Customize Totalcmd.inc file dialog box.

Recent Files

Displays the most recently used files to quickly open one of them.

Exit

Closes the current file and quits the program. If you try to quit before saving changes to your work, you'll be prompted to save your work first.


Edit Menu Commands

Add Menu

Creates a top level menu item.

Keyboard shortcut: | Ctrl+M
Toolbar button: | toolbar icon

Add Submenu

Creates a submenu item inside the selected menu item.

Keyboard shortcut: | Ctrl+G
Toolbar button: | toolbar icon

Add Separator

Adds a separator line just below the selected item.

Keyboard shortcut: | Ctrl+L
Toolbar button: | toolbar icon

Add Comment

Adds comment lines to your menu file.

Keyboard shortcut: | Ctrl+W
Toolbar button: | toolbar icon

Repeat

Repeats the selected item. (this is useful to have the same command appear in more than one menu.)

Keyboard shortcut: Ctrl+E

Start Menu

Insert the Total Commander start menu at the actual position in the main menu bar.

Keyboard shortcut: Ctrl+J

Help_Break

Insert a break in the main menu. After that break, all menus will be right adjusted.

Keyboard shortcut: Ctrl+K

Move Up

Moves the selected item one place up.

Keyboard shortcut: | Ctrl+U / Ctrl+Up arrow
Toolbar button: | toolbar icon

Move Down

Moves the selected item one place down.

Keyboard shortcut: | Ctrl+Y / Ctrl+Down arrow
Toolbar button: | toolbar icon

Move To...

Shows "Move to" dialog box.

Tip In "Move to" dialog box, press Ctrl+Enter to move commands and submenus under the menu not the menu itself. Useful to quickly merge the contents of two menus.

Keyboard shortcut: | Ctrl+T / Ctrl+Right arrow
Toolbar button: | toolbar icon

Sort Selected Menu

Sorts items in the selected menu only alphabetically from A to Z.

Tip Only one level will be sorted, that is if the selected menu has any submenu then items under this submenu will not be sorted.

Import Captions...

Imports caption of the command items from another menu file.

Useful to:

  • Translate a menu file from a language to another.
  • Save time when creating a new menu file. Just build your menu structure then import command captions from an already exist menu file.
Keyboard shortcut: Ctrl+I

Delete

Deletes the selected item.

Keyboard shortcut: | DEL
Toolbar button: | toolbar icon

Rename

Renames the selected item.

Keyboard shortcut: | Ctrl+R / F2
Toolbar button: | toolbar icon

Definition

Displays the location in the menu tree where the selected command list item is defined and vice versa.

Keyboard shortcut: | Ctrl+D / Alt+Up, Down or Mouse left button
Toolbar button: | toolbar icon


Search Menu Commands

Find...

Displays Find dialog box for searching the menu or the command list for the specified text. The search is performed from the first item to the last item. If the string is not found or if there isn't anymore occurrence of the text the message "Cannot find ......" is displayed.

Keyboard shortcut: | Ctrl+F
Toolbar button: | toolbar icon

Find dialog box

Main Menu Editor Find box

Options

  • Description: search specified text in the description column.
  • Command: search specified text in the command column.
  • Code: search specified text in the code column.
  • Match whole word only: This option allows the search to be restricted to whole words only. This is useful to make searching more specific.
  • Clear List: Click this button to delete all previous search text.

Find Next

Repeats the previous Find command, the next occurrence of the find text will be found (if present) or the message "Cannot find ......" is displayed.

Keyboard shortcut: F3

Tip Right click on the toolbar Find button to execute Find Next command.

This feature can be disabled by adding ToolbarIgnoreRightClick=1 to the program INI file "ultra tc editors.ini" under MainMenuEditor section.


View Menu Commands

Toolbar

Shows or Hides the Toolbar, which includes buttons for some of the most common commands, such as File Save. A check mark appears next to the menu item when the Toolbar is displayed.

To customize the toolbar, right click on it and execute "Customize..." command. Customize toolbar dialog will popup.

Status Bar

Shows or Hides the status bar. A check mark appears next to the menu item when the status bar is displayed.

Command List

Shows or Hides Total Commander internal commands list. A check mark appears next to the menu item when the command list is displayed.

Toolbar button: toolbar icon

Category List

Shows or Hides the Totalcmd.inc file categories list. A check mark appears next to the menu item when the categories list is displayed.

Vertical Panels

Shows the two panels windows side by side instead of above each other. A check mark appears next to the menu item when the two panels are side by side.

Swap Panels

Exchanges the two panels position.

Expand Tree

Unfolds all menus in the tree.

Keyboard shortcut: Ctrl+F1

Collapse Tree

Folds all menus in the tree.

Keyboard shortcut: Ctrl+F2

Sorted List

Sorts the commands list. A check mark appears next to the menu item when the list is sorted.

Toolbar button: toolbar icon

The list includes the following three columns:

  • Description
  • Command
  • Code

To sort any column click its header. A small black arrow appears next to the sorted column shows you the sort order.

Options...

Displays the program options dialog box.

Toolbar button: toolbar icon


Context Menu Commands

The context menu is the menu that appears when you are right-click on the command list (right panel). The context menu contains the following commands.

Command list context menu

  • Add: add the selected item(s) to the current selected menu.
    (Status Bar always displays the current menu).
  • Remove: remove the selected item(s) from the menu tree.
  • Select All: select all the commands in the list. (comment items will not selected).
  • Select All Active: select all active commands
    (Status Bar displays how many commands are selected).
  • Select All Inactive: select all inactive commands
    (Status Bar displays how many commands are selected).
  • Definition: Displays the location in the menu tree where the selected command is defined.
  • Create Full Menu: Closes the current file and creates a new file include all Total Commander internal commands organized according to categories in the Totalcmd.inc file.
  • Customize Totalcmd.inc file...: Displays Customize Totalcmd.inc file dialog box.
  • Category List: Submenu contains all categories in the Totalcmd.inc file.
    Right click on a category will directly show the category list.


Layout Tab Options

Main Menu Editor Layout tab options

check box Show tree icons

Displays or hides the menu tree icons.

check box Show tree lines

Displays or hides the lines between the menu tree items.

check box Show grid lines

Displays or hides the command list grid lines.

check box Fixed borders

Displays or hides a thin border around the window panels.

check box Flat user interface

Displays or hides the 3D effects.

check box Show save mode in save button

Displays or hides the current save mode character above the save button.

check box Show icons for internal commands

Displays associated icon for Total Commander internal commands, these icons are stored in the file Wcmicons.dll or WcIconEx.dll.

Separator Line:

Allows you to set the style of the separator line.


Icons Tab Options

Main Menu Editor Icons tab options

check box Use default icons

Displays the program default icons.

Size:

Displays the icons in different sizes.

To use your won icons

  1. Clear the option Use default icons.
  2. Select the icon you want to change it.
  3. Double click the selected icon or click the Change... button to browse for new icon file.
  4. Repeat step 2 and step 3 for each icon you want to change.


Color and Font Tab Options

Main Menu Editor Color and Font tab options

To change any color, click it and select another color from the choose color dialog box.

To change the program font, click the Change... button and select another font.

Note

If your language characters doesn't appear correctly, select your language Character set (Script) from the Font dialog box.


Operation Tab Options

Main Menu Editor Operation tab options

radio box Default Totalcmd.inc file

When this option is selected, the program will read Total Commander internal commands from the default Totalcmd.inc file.

radio box Other file:

When this option is selected, the program will read Total Commander internal commands from the specified file.

check box Automatically load last file

Specifies that the last file you were working on is automatically opened when you start the program.

check box Associate TC menu files (*.mnu) with the program

Associates Total Commander menu files ( *.mnu ) with the program, so you can open any menu file (*.mnu) by double click it.

check box Collect comments in group (Recommended)

Collects multilines comment inside a group. (this option effect will take place when you restart the program or closing the current file and opens another on.)

check box Auto restart Total Commander after saving changes

Specifies whether the program should automatically restart Total Commander each time you save changes to the current file.

Number of spaces to indent each menu in saved file:

Sets the number of spaces which indent each menu and submenu in the menu file, this value must range between 1 and 32.


Language Tab Options

Main Menu Editor Language tab options

radio box Use default language

If selected, the program interface language will be English.

radio box Other:

If selected, the program will load the interface language from the specified file.

To change the program language:

  1. Select the option Other.
  2. Click the '>>' button and select your language file.


Customize Totalcmd.inc file

Overview

Totalcmd.inc file contain all Total Commander internal commands. In many of Total Commander dialog box there is a dropdown list shows these commands, like toolbar configure dialog box and change start menu dialog box.

Usually searching for a specific command inside this dropdown list is difficult, but organizing these commands can make searching for a command more easily. Customize Totalcmd.inc dialog box gives you two ways for sorting commands in Totalcmd.inc file:

  1. Categorized
  2. Alphabetic

Customize Totalcmd.inc dialog box

Customize Totalcmd.inc file dialog box

Tabs

  • Categorized tab: Use this tab to sort Totalcmd.inc commands according to your Total Commander Main Menu file structure, that is each menu commands will be grouped together under a category named by this menu caption. All commands that aren't existing in the Main Menu will be collected at the end of the Totalcmd.inc file.
  • Alphabetic tab: Use this tab to sort Totalcmd.inc commands alphabetically from A to Z according to its name.
  • As it is tab: Use this tab to change Totalcmd.inc commands description or Totalcmd.inc categories style. (Totalcmd.inc commands will not be sorted at all.)

Options

  • Separator Style: here you can format the Totalcmd.inc file categories style.
  • Add separator for each submenu check this option to create a category for each submenu.

    • Alert If you are using Total Commander 7.0 then don't change the default separator options, otherwise the new Total Commander 7.0 Choose command dialog box will not looks as expected!

  • Use menu caption for description check this option to replace the default command description with the menu caption.
  • Add Command Code to Description check this option to add the command code to its description.

Preview window

  • Preview window shows how commands in Totalcmd.inc file will look at Total Commander (version 6.5x and previous) dropdown list.


Hints and Tips

Tip The toolbar Save button has additional three commands not included in the File menu, enable you to save the commands in the menu file in three modes.

Save button dropdown menu

  • Save Command As Text
    e.g. MENUITEM "Select &All\tCtrl Gray +",cm_selectall
  • Save Command As Decimal
    e.g. MENUITEM "Select &All\tCtrl Gray +",523
  • Save Command As Hexadecimal
    e.g. MENUITEM "Select &All\tCtrl Gray +",$20B

When you select one from this list, it will be the default mode for Save button and you don't have to dropdown this list again. The save button will marked (optionally) with the save mode as follow:

  • Character T for text mode.
  • Character D for decimal mode.
  • Character H for hexadecimal mode.

Tip This program cannot edit Total Commander Start Menu or delete it from the main menu bar, it is only can set the position of it.

To delete (hide) the Start menu from the Total Commander main menu bar do the following:

  1. Run Configuration Editor.
  2. On the File menu, click Open Data File... and choose English.cedf file. (skip this step if English.cedf is the current data file)
  3. On the Search menu, click Find....
  4. In the Find dialog box, type RestrictInterface, select Key Name option and click Find Next button.
  5. Double click RestrictInterface key and set its value to 1
  6. On the File menu, click Save and Restart Total Commander.

Tip To start a new file using your won predefined menus

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key NewFileTemplate under [MainMenuEditor] section.
  3. Set the key NewFileTemplate value to your desired menus you want to start with.

Example:

NewFileTemplate = "&Files |&Edit |&Mark |&View |&Commands |&Net |&Options |STARTMENU |HELP_BREAK |&Help"

Note:

You must separate each menu name using this character |

Tip Press <Shift> while adding a command to add its name instead of description.

Tip For easy adding/removing a command Press CTRL+ Space this will add/remove the current selected command and switch to the next one.

Tip For easy definition press ALT+Up, ALT+Down or ALT+ Mouse left button

Tip If you want one click to start inplace rename a tree menu item:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key OneClickToRenameItem under [Common] section.
  3. Set the key OneClickToRenameItem value to 1

Tip By default the program will append the command Default hotkey, User-defined hotkey and Alias when adding it to the menu, to change how this feature work:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key AutoAppendHotkeys under [MainMenuEditor] section.
  3. Set the key AutoAppendHotkeys to sum of the following values:
  • 0= Disable
  • 1= Append default hotkey.
  • 2= Append user-defined hotkey.
  • 4= Append alias.

Notes

  • The data file "tc default hotkeys.hky" must be exist on its default path to append the default hotkey.
  • User-defined hotkeys and Aliases are refreshed only when starting the program, opening a menu file or creating a new file.

Tip Drag and Drop tips:

  • If you drag a menu item (command, menu or separator) to an empty menu (folder icon) it will be added into this menu directly. To move it out drag it again to the same menu.
  • If you drag a menu to none empty menu (folder icon) it will be added just above this menu.
  • To add a menu item into none empty menu when it is collapsed, wait about second and half until the menu expand.

Tip If you want to open a file saved in UTF-8 encoding without BOM, press Shift while opening it to make the program read it as UTF-8 not ANSI.

Alert If the current file is UTF-8 encoded, and it is containing characters from code page different than your system's default code page, they will be appearing as a question mark, and they will be lost while saving if they were renamed inside the program. A warning message will popup before saving UTF-8 encoded file. This warning message can be disabled by adding UTF8Warning=0 under [MainMenuEditor] section in "ultra tc editors.ini"

IMPORTANT:
Please backup your UTF-8 encoded file before saving, because saving in UTF-8 encoding not always success for some languages, e.g. Chinese.


Versions history

Legend

Added Added

Fixed Fixed

Changed Changed or Improved

Version 6.00 --- 3 March, 2011

Added Support Wcmd_*.mnu and Wcmd_*.inc in UTF-8 format with or without BOM.

Added Show icons of TC internal commands from the file WcmIcons.dll or WcIconEx.dll

Added Right click on the toolbar, shows a new dialog for customizing the toolbar.

Added Append TC hotkeys from the section [ShortcutsWin] too.

Added When double click on a command in the menu tree, go to that command in the commands list.

Added Preserve the command position in the menu tree when continuously double click on that command in the list.

Added Enhancement to auto scrolling the tree while dragging.

Added New hotkeys Ctrl+C and Ctrl+Ins to copy selected command data to the clipboard.

Added New icons.

Added "Move To" dialog: remember the last selected menu.

Added New color option for "Inactive command" (command that not exists in the main menu)

Added New button "Find" added to the toolbar.

Added Close the program by pressing ESC. (can be enabled via CloseOnEsc=1 under [Common] section in "ultra tc editors.ini")

Added Restart TC function restarts TC with the last visited path of the active tab if this tab is "Locked, but directory changes allowed".

Fixed Totalcmd.inc was not translated if "WCMD_xxx.INC" and "WCMD_xxx.MNU" are not using the same name, e.g. "WCMD_RUS.INC" and "WCMD_RUS_EXT.MNU".

Version 5.54 --- 12 October, 2009

Fixed Find dialog remains using previous language interface if the program language changed while it is visible.

Changed Remove nag screen, the program now is freeware.

Changed Display the full path of the current file in the title bar.

Version 5.53 --- 17 August 2008

Fixed Windows Vista: Vertical scroll bar in the right panel was partially visible.

Changed The program icon changed.

Version 5.52 --- 24 March 2008

Added New command Check Mnemonics added to File menu.

Added New command Import Captions added to Edit menu.

Added New command Sort Selected Menu added to Edit menu.

Added Warning message popup if duplicate mnemonic have found while editing command title.

Added Auto append the command User-defined hotkey and Alias when adding it to the menu. (optionally)

Added Support opening menu files by drag and drop.

Added While focus on the menu panel, press Shift+Up/Down defines and selects the same command in the command panel.

Added Move To dialog box: press Ctrl+Enter to move commands and submenus under the menu not the menu itself.

Added Optimize Create Full Menu command for speed.

Version 5.51 --- 24 July, 2007

Fixed Cannot use language file if the program start from a removable or network disk.

Fixed While focus on the command list, pressing <Ctrl+D>, <Ctrl+R> then <Delete> was deleting the selected item not its text.

Version 5.50 --- 12 July, 2007

Added New panel for Totalcmd.inc categories.

Added Auto translate Totalcmd.inc file if the translation file exist.

Added Show extended command in both usercmd.ini and wcmd_xxx.ini.

Added Support Total Commander 7.0 redirect feature.

Added Apply Windows XP style to the program.

Version 5.14 --- 29 June, 2006

Added New command Create Full Menu added to the File menu.

Added Right click on the command list, popup a list of all categories in the Totalcmd.inc file.

Added New shortcuts Ctrl+F1/Ctrl+F2 for Expand Tree/Collapse Tree commands on View menu.

Version 5.12 --- 4 September, 2005

Added New button "Clear List" added to Find dialog box.

Added Support using variable path "utceditors:\" instead of the program real path.

Added Press 'Esc' key to close Find dialog box.

Version 5.10 --- 20 June, 2005

Added New function "Find".

Added Auto append the command default hotkey when adding it to the menu. (optionally)

Added New shortcut for 'Move Up', 'Move Down' and 'Move To...' commands <Ctrl+Up>, <Ctrl+Down> and <Ctrl+Right> respectively.

Added Press <Shift> while adding a command to add its name instead of description.

Added New setting key added to the program section in the file "ultra tc editors.ini": CommandListFullRowSelect.

Fixed Drag and drop a menu command to immediately next one has no effect (top to down).

Fixed Error occur when trying to move a menu to itself. (e.g. moving File menu to File menu!).

Fixed Choose font dialog box wasn't pre-select current font size.

Version 5.02 --- 10 April, 2005

Added Program settings file "ultra tc editors.ini" path and name can be customized.

Fixed Minor bug fixed.

Version 5.01 --- 28 March, 2005

Added Open Total Commander default Main menu file at startup.

Added The program remember last sort order and last sorted column.

Version 5.00 --- 15 March, 2005

Added New function "Save and Restart Total Commander".

Added Change the program language without restarting it.

Added Change the commands list icons without restarting the program.

Added Ability to start new file with your won predefined menus.

Fixed Command list column headers width were not restored correctly on systems that use comma ',' as Decimal symbol.

Changed Twice click on a menu tree item to inplace rename instead of one click.

Version 4.00 --- 9 September, 2004

Added The program remember the command list column headers position and width.

Fixed Minor bug fixed.

Changed The program become one of Ultra TC Editors package.

Version 3.02 --- 25 July, 2004

Added Press Ctrl+Space key to add/remove the selected command and switch to the next one.

Version 3.01 --- 26 June, 2004

Fixed when using local language some program user interface doesn't appear in this language.

Version 3.00 --- 24 June, 2004

Added Localization, the program comes with English language file you can translate this file to your local language and use it.

Version 2.04 --- 25 May, 2004

Fixed Minor bug fixed.

Version 2.03 --- 24 May, 2004

Added Any command in menu file has not an identifier in Totalcmd.inc file will appear with Unchecked icon.

Added New tab strip "As it is" added to Customize Totalcmd.inc dialog box.

Added New option "Add Command Code to Description." added to Customize Totalcmd.inc dialog box.

Fixed Always ask for (Totalcmd.inc) file path if this file is hidden.

Fixed The command description was not saved when you customize Totalcmd.inc file (Categorized).

Fixed Any repeated command in the menu wasn't deleted when you try to delete it.

Version 2.02 --- 27 April, 2004

Fixed Error occur when reading some none command entry in Totalcmd.inc file.

Fixed Trying to move a comment Up/Down by pressing toolbar button Up/Down was not moved, but the current menu item was moved instead.

Changed The "Add Comment" shortcut changed from [CTRL+V] to [CTRL+W] to solve the conflict with standard "Paste" shortcut [CTRL+V].

Changed The "Repeat" shortcut changed from [CTRL+C] to [CTRL+E] to solve the conflict with standard "Copy" shortcut [CTRL+C].

Changed The "Add Separator" shortcut changed from [CTRL+H] to [CTRL+L] to solve the conflict with Treeview, Listview and Text controls backspace shortcut [CTRL+H].

Changed The minimum font size changed from 10 to 8 points.

Version 2.01 --- 24 April, 2004

Added Support Russian language and other languages.

Added Set the font of the Menu tree in Move To... dialog to the current font settings.

Added If (Totalcmd.inc) file contain an error, the line number that contain this error will be shown.

Fixed Error occur when press CTRL+D while the command list is hidden.

Fixed Error occur when press CTRL+A while the command list is hidden.

Fixed Error occur when press CTRL+F7 while the command list is hidden.

Fixed Error occur when press CTRL+F8 while the command list is hidden.

Fixed Error occur when the program start and click command list very right hand free space so that the selection is deleted, and press the button "Definition".

Changed The comment group default name changed from "Comment Heading" to "Comments"

Changed When saving the menu file the comment group name line (Written only if you have changed the default name) is marked with ";..." instead of the previous long and ugly line ";DO NOT REMOVE OR MODIFY THIS LINE___"

Changed The save mode (Text, Decimal or Hexadecimal) will not saved into the menu file, instead it will be determined automatically.

  • I have made these changes in order to not write anything into your menu file you did not actually wrote it.

Version 2.00 --- 05 April, 2004

Added New command (Customize Totalcmd.inc...) enable you to arrange the commands in Totalcmd.inc file to be exactly like your main menu or you can arrange them sorted.

Added Drag and Drop supported now, from the commands list to the menu tree or within the menu tree itself.

Added Multi select commands feature enable you to add/remove more than one command at once.

Added Show any comment in the menu file and you can add your comments at any place in the menu file.

Added Support Total Commander 6.02 internal's command file format.

Added Many customization options added to Options dialog.

  • Full color and font customization options.
  • Icons resizing option.
  • Icons change option enable you to use your own icons set instead of the program default icons.
  • Options to add your own text for fixed menu items like Separator, StartMenu and Help_Break.
  • And many other options.

Added Recent files list added to the program File menu and to toolbar Open button.

Added New toolbar button to show/hide the command list if you need more space when editing the menu tree.

Added Status bar added to show some useful information.

Added New commands added to Commands list right click menu.

  • Add to add the selected command(s) to the menu.
  • Remove to remove the selected command(s) from the menu.
  • Select All to select all commands.
  • Select All Checked to select all checked commands only.
  • Select All Unchecked to select all unchecked commands only.

Added Associate TC menu file (*.mnu) with the program, enable you to open these files by double click.

Added Save all program settings in Utcmedit.ini file in program folder.

Added Enhancement all program operations speed, specially opening menu file and sorting the command list.

Added Progress bar appear when perform tasks that takes long time to execute.

Added Optionally toolbar Save button marked with current save mode.

Version 1.00 --- 07 February, 2004

  • First release.


Ultra TC Start Menu Editor logo

Ultra TC Start Menu Editor is a powerful tool which allows you to edit Total Commander start menu. It is similar to Total Commander built-in editor but with more functions, more easily and fast.

Start Menu Editor screen shoot


File Menu Commands

Open...

Opens an existing Total Commander configuration file (Wincmd.ini) that contains start menu entries you want to edit.

Keyboard shortcut: | Ctrl+O
Toolbar button: | toolbar icon

Save

Saves changes you already did to the start menu. This button will be disabled after saving and enabled again when there is any change.

Keyboard shortcut: | Ctrl+S
Toolbar button: | toolbar icon

Save and Restart Total Commander

Saves changes and restarts Total Commander if it is running, useful to make Total Commander reload the start menu with changes you already did.
This command available in Start Menu Editor only.

Keyboard shortcut: Ctrl+Q

Alert Total Commander will restart using settings in the file you are editing, therefore if this file isn't your default Wincmd.ini you may find some settings out of date.

Export...

Opens an existing Total Commander configuration file (Wincmd.ini) and export the current start menu entries. (this command works like Save As...)

Keyboard shortcut: Ctrl+E

Import...

Opens an existing Total Commander configuration file (Wincmd.ini) and import start menu entries from it.

Keyboard shortcut: Ctrl+I

Export To Totalcmd.inc...

Displays Export dialog box.

Check Mnemonics...

Search current file for duplicated mnemonic or items not containing mnemonics.

Recent Files

Displays the most recently used files to quickly open one of them.

Exit

Closes the current file and quits the program. If you try to quit before saving changes to your work, you'll be prompted to save your work first.


Edit Menu Commands

Add Menu

Creates a top level menu item.

Keyboard shortcut: | Ctrl+M
Toolbar button: | toolbar icon

Add Submenu

Creates a menu item inside the selected item.

Keyboard shortcut: | Ctrl+G
Toolbar button: | toolbar icon

Add Separator

Adds a separator line just below the selected item.

Keyboard shortcut: | Ctrl+L
Toolbar button: | toolbar icon

Add Command

Adds a command item to the tree.

Keyboard shortcut: | Ctrl+W |
Toolbar button: | toolbar icon | Start Editor mode
Toolbar button: | toolbar icon | Directory Editor mode
Toolbar button: | toolbar icon | Extended Commands Editor mode

Add Me

Adds a link to the program at the end of your menu.

Move Up

Moves the selected item one place up.

Keyboard shortcut: | Ctrl+U / Ctrl+Up arrow
Toolbar button: | toolbar icon

Move Down

Moves the selected item one place down.

Keyboard shortcut: | Ctrl+Y / Ctrl+Down arrow
Toolbar button: | toolbar icon

Move To...

Displays "Move to" dialog box.

Tip In "Move to" dialog box, press Ctrl+Enter to move commands and submenus under the menu not the menu itself. Useful to quickly merge the contents of two menus.

Keyboard shortcut: | Ctrl+T / Ctrl+Right arrow
Toolbar button: | toolbar icon

Cut

Deletes the selected item and places its data on the Windows clipboard.

Keyboard shortcut: Ctrl+X

Copy

Places the selected item data on the Windows clipboard.

Keyboard shortcut: Ctrl+C

Paste

Creates a new item and reads its properties from the Windows clipboard.

Keyboard shortcut: Ctrl+V

Sort All Menus

Sorts all items in all menus and submenus alphabetically from A to Z.

Sort Selected Menu

Sorts items in the selected menu only alphabetically from A to Z.

Tip Only one level will sorted, that is if the selected menu has any submenu then items under this submenu will not sorted.

Open in TC

Opens the selected item path (if it is refer to an existing file or folder) in Total Commander left panel.
To configure this command, read this hint.

Keyboard shortcut: F8 / Enter

Delete

Deletes the selected item.

Keyboard shortcut: | DEL
Toolbar button: | toolbar icon

Rename

Renames the selected item.

Keyboard shortcut: | Ctrl+R / F2
Toolbar button: | toolbar icon

Properties

Displays the standard Windows property sheet for the selected item if it is refer to an exist file or folder.

Keyboard shortcut: Ctrl+P / Alt+Enter


Search Menu Commands

Find...

Displays Find dialog box for searching the menu for the specified text. The search is performed from the first item to the last item. If the string is not found or if there isn't anymore occurrence of the text the message "Cannot find ......" is displayed.

Keyboard shortcut: | Ctrl+F
Toolbar button: | toolbar icon

Find dialog box

Start Menu Editor Find box

Options

  • Title: search specified text in the menu item title.
  • Path: search specified text in the menu item command path.
  • Match whole word only: This option allows the search to be restricted to whole words only. This is useful to make searching more specific.
  • Clear List: Click this button to delete all previous search text.

Find Next

Repeats the previous Find command, the next occurrence of the find text will be found (if present) or the message "Cannot find ......" is displayed.

Keyboard shortcut: F3


View Menu Commands

Toolbar

Shows or Hides the Toolbar, which includes buttons for some of the most common commands, such as File Save. A check mark appears next to the menu item when the Toolbar is displayed.

To customize the toolbar, right click on it and execute "Customize..." command. Customize toolbar dialog will popup.

Always on Top

Places the program window above all other program windows running in your system. This command is useful when dragging items from other programs like Total Commander or Windows Explorer.

Start Menu

Switch to 'Start Menu' mode.

Keyboard shortcut: F5

Directory Menu

Switch to 'Directory Menu' mode.

Keyboard shortcut: F6

Extended Commands

Switch to 'Extended Commands' mode.

Keyboard shortcut: F7

Expand Tree

Unfolds all menus in the tree.

Keyboard shortcut: Ctrl+F1

Collapse Tree

Folds all menus in the tree.

Keyboard shortcut: Ctrl+F2

Options...

Displays the program options dialog box.

Toolbar button: toolbar icon


Layout Tab Options

Start Menu Editor Layout tab options

check box Show tree icons

Displays or hides the menu tree icons.

check box Show tree lines

Displays or hides the lines between the menu tree items.

check box Show grid lines

Displays or hides the command list grid lines. (Choose Command dialog box)

check box Fixed borders

Displays or hides a thin border around the window panels.

check box Flat user interface

Displays or hides the 3D effects.

check box Show file icon

If checked then any item refer to an exist file will appear with the shell icon of this file (like Explorer). This option working with files only not folders.

Alert If this option is selected then expanding any menu will be slow specially if it is containing a lot of commands refer to files on your disks.

Separator Line:

Allows you to set the style of the separator line.


Icons Tab Options

Start Menu Editor Icons tab options

check box Use default icons

Displays the program default icons.

Size:

Displays the icons in different sizes.

To use your won icons

  1. Clear the option Use default icons.
  2. Select the icon you want to change it.
  3. Double click the selected icon or click the Change... button to browse for new icon file.
  4. Repeat step 2 and step 3 for each icon you want to change.


Color and Font Tab Options

Start Menu Editor Color and Font tab options

check box Apply font settings to command property fields

If checked then the command property fields will take the menu tree font settings.

To change any color, click it and select another color from the choose color dialog box.

To change the program font, click the Change... button and select another font.

Note

If your language characters doesn't appear correctly, select your language Character set (Script) from the Font dialog box.


Operation Tab Options

Start Menu Editor Operation tab options

check box Automatically use command as item title

Specifies whether the program should automatically extract file or folder name and assign it for title of the selected item.

check box Remove file extension from item title

Specifies whether the program should automatically remove file extension from title of the selected item.

check box Automatically create new command or select next one

Specifies whether the program should automatically select next item after changing current item or create new item if current item is the last one.

check box Search for existence of files or folders on network places

Specifies whether the program should search for files or folders on the network places.

check box Search for existence of files or folders on removable drives

Specifies whether the program should search for files or folders on removable drives like floppy disk or CD-Rom.

check box Auto restart Total Commander after saving changes

Specifies whether the program should automatically restart Total Commander each time you save changes to the current file.

The following options are exist in Start Menu mode only:

check box Always export to Totalcmd.inc file after saving menu

Specifies whether the program should exports Total Commander Start Menu entries after saving it to Totalcmd.inc file without any prompt.

check box Always remind me to export changes

Specifies whether the program should display a message box asks you to export Total Commander Start Menu entries.


Language Tab Options

Start Menu Editor Language tab options

radio box Use default language

If selected, the program interface language will be English.

radio box Other:

If selected, the program will load the interface language from the specified file.

To change the program language:

  1. Select the option Other.
  2. Click the '>>' button and select your language file.


Exporting Start Menu to Totalcmd.inc file

What is Totalcmd.inc file?

Totalcmd.inc file is a text file reside in Total Commander installation folder, it is contain all Total Commander internal commands, these commands are grouped into many categories according to their functions e.g.[__FileOperations__], [__Configuration__], [__Network__] etc...

There is a special category by default named [__User__] under it you can specify any of TC Start Menu command, in this case the Start Menu commands will be treated as if they are TC internal commands.

Why exporting Start Menu to Totalcmd.inc file?

You will need to export Start Menu to Totalcmd.inc file if you want to:

  • Assign a hotkey for a Start Menu command different from the predefined hotkeys in Start Menu Editor. (Ctrl+Alt+F1 to F12 and Ctrl+Alt+Shift+F1 to F12).
  • Use a Start Menu command into your Total Commander Main Menu or for a toolbar button.

Export dialog box

Export TC Start Menu dialog box

  • Preview Window: here you see how the user commands category will look.

Options

  • Export command only (Recommended)
    Usually Start Menu is organized using submenus and separators, if you want to export these entries too, uncheck this option otherwise only Start Menu entry that refers to a real command will be exported.
  • Add command code to description
    Useful if you used to add the command code to the description via Customize Totalcmd.inc dialog box.
  • Update Wincmd.ini [Shortcuts], [ShortcutsWin] and [Alias] sections
    If you are extensively exporting Start Menu to Totalcmd.inc file and then assign hotkey or alias by Total Commander options dialog box or by Hotkeys Editor for these exported commands, this option will be very helpful because when you change start menu by adding, deleting or just re-arrange the entries, these hotkeys or aliases will not work correctly. This option will update Wincmd.ini [Shortcuts], [ShortcutsWin] and [Alias] sections to make each user command preserve its original hotkey/alias.
    This option will be enabled only if Wincmd.ini [Shortcuts], [ShortcutsWin] or [Alias] sections have an entry refer to a user command.
  • Command prefix: here you can set your won prefix. (only characters a-z, A-Z and underscore '_' are accepted).
  • Category name: here you can set your won category name for user commands.

IMPORTANT:

  • Don't change Command Prefix outside this dialog box (e.g. by notepad or any other text editor), otherwise the program will not detect user commands under Wincmd.ini [Shortcuts], [ShortcutsWin] or [Alias] section if they saved there in text mode.
  • Be sure that Main Menu Editor and/or Hotkeys Editor are not running while exporting to Totalcmd.inc file, because the two programs will not recognize changes happened to Totalcmd.inc file and will continue using the old Totalcmd.inc file contents and this could cause unpredicted errors.


Parameters list

Overview

Parameters list provides speed access to all of Total Commander special parameters. To display the parameters list click the percent button Percent button beside the Parameters text box. (available only in Start Menu Editor and Extended Commands Editor)

When you click the percent button, a predefined list of all available parameters will appear to select what you want.

To edit the parameters list, click on the drop down arrow beside the percent button and select the Edit... command.

To show the parameters list as a menu instead of window, click on the drop down arrow beside the percent button and select Show as menu option .

Edit Parameters List window

Edit parameters list window

Options:

check box Default

Switches between the default parameters list and user-defined list.

Buttons:

  • toolbar icon Moves the selected parameter one place up. (shortcut Ctrl+Up)
  • toolbar icon Moves the selected parameter one place down. (shortcut Ctrl+Down)
  • toolbar icon Adds a new parameter just under the selected item. (shortcut Ctrl+N)
  • toolbar icon Adds a separator just under the selected item. (shortcut Ctrl+L)
  • toolbar icon Deletes the selected parameter. (shortcut Del)
  • toolbar icon Edits the selected parameter. (shortcut F2/ double click)
  • OK: closes the dialog box and saves any changes you have made.
  • Cancel: closes the dialog box without saving any changes you have made.

Notes:

  • You can add multi parameters in one line, e.g. %P%N inserts file name with full path.
  • When the parameters list shown as a window, right click on a parameter will pass it to the main window without closing the parameters window.
  • Parameters already exist in the parameters field will be bold and red (window mode) or checked (menu mode).


Hints and Tips

Tip The program by default will start with the last mode you were used before closing it. You can use the following command line parameters to control how the program start:

  • /s always start in Start Menu mode.
  • /d always start in Directory Menu mode.
  • /e always start in Extended Commands mode.
  • /so Only Start menu mode. switch to other modes is disabled.
  • /do Only Directory menu mode. switch to other modes is disabled.
  • /eo Only Extended Commands mode. switch to other modes is disabled.

Tip If the option "Show file icon" isn't selected then any command in the menu can appear with one of the following symbols:

  • Checked symbol Checked symbol if the command is one of Total Commander internal commands.
  • Run symbol Run symbol if the command is refer to an existence file.
  • Star symbol Star symbol if the command is refer to an existence folder.
  • Question symbol Question symbol if the command is refer to a broken link to file or folder.

Tip To apply changes you have made in Total Commander Start Menu, save these changes and do one of the following:

  • On Total Commander Start menu click Change Start Menu.. and when the Change start menu dialog box appear, click OK button immediately.
  • Restart Total Commander.
  • Start another copy of Total Commander.
  • Execute built-in function Save and Restart Total Commander.

Tip To apply changes you have made in Total Commander Directory Menu, there is no need to restart Total Commander, just save the changes and switch to Total Commander window (if it is running) and open directory menu by any manner you prefer. (e.g. press Ctrl+D)
Also there is no need to restart Total Commander to apply changes you have made in Extended Commands.

Tip Drag and Drop tips

  • If you drag a menu item (command, menu or separator) to empty menu (folder icon) it will be added into this menu directly. To move it out drag it again to the same menu.
  • If you drag a menu to none empty menu (folder icon) it will be added just above this menu.
  • To add a menu item into none empty menu when it is collapsed, wait about second and half until the menu expand.
  • You can drag any object refer to system file or folder from any other application which supports drag & drop (e.g. Total Commander, Windows Explorer, Windows Desktop or even shortcut from Windows Start menu).
  • You can drag any file or folder to desired menu. (you can drag more than one file, folder or both file and folder together)
  • You can drag file or folder to 'Command' field to change the selected menu item command.
  • You can drag a file or folder to 'Start Path' field. (if you drop a file here the parent folder will be taken)
  • You can drag a file or folder to 'Parameters :' field.
  • Press Ctrl while dropping files to insert cd command in front of file name.
    Note: cd <filename> work only with Total Commander 7.0 and later.

Alert By default the program will disable Editing, Importing and Exporting the menu in Total Commander configuration file you try to open according to the value of RestrictInterface key in this file. To disable this feature:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key RestrictEdit under [Common] section.
  3. Set the key RestrictEdit value to 0

Tip You can change how "Open in TC" command on "Edit" menu passing selected item path to Total Commander as follow:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key OpenInTCParam under [StartMenuEditor], [DirectoryMenuEditor] or [ExtendedCommandsEditor] section.
  3. Set the key OpenInTCParam value to any combination of the following Total Commander command line parameters
    /O, /N, /L, /R, /S, /T, (/P=R or /P=L), /D=<x>.
    (for more information about these parameters, read Total Commander help file.)

Example:

  • OpenInTCParam=/O /L
    Always passing selected item path to Total Commander left panel.
  • OpenInTCParam=/O /R
    Always passing selected item path to Total Commander right panel.
  • OpenInTCParam=/O /S (default)
    Always passing selected item path to Total Commander active panel.
  • OpenInTCParam=/O /S /T
    Always passing selected item path to Total Commander active panel in new tab.
  • OpenInTCParam=/N /P=R /L
    Opens a new Total Commander window, activate right panel and pass selected item path to left panel.

Notes:

  • If the item path refers to a file, the parent folder will passed.
    If you are using Total Commander 7.0 or higher, this file will be selected.
  • You can execute this command by three ways:
  1. From Edit menu
  2. Double click an item
  3. Press F8

Tip If you want one click to start inplace rename a tree menu item:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key OneClickToRenameItem under [Common] section.
  3. Set the key OneClickToRenameItem value to 1

Tip Total Commander start menu is limited to only 199 items, including separators and submenus entry. If you want more than 199 items in TC start menu, do the following:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key StartMenuMaxItems under [StartMenuEditor] section.
  3. Set the key StartMenuMaxItems to desired value.

Important:

  • Don't use TC built-in editor to edit the start menu otherwise all items above the first 199 items will be lost.
  • Only the first 199 items will be exported to the file "Totalcmd.inc" when you choose the command Export To Totalcmd.inc....

Tip Total Commander directory menu can be used to run programs exactly like Total Commander start menu, to show parameters list and window state also in Directory Menu Editor:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key ShowParamList under [DirectoryMenuEditor] section.
  3. Set the key ShowParamList value to 1


Versions history

Legend

Added Added

Fixed Fixed

Changed Changed or Improved

Version 6.01 --- 20 July, 2011

Added New commands added to the Edit menu, Cut, Copy and Paste.

Added Properties command on the Edit menu displays the number of commands under the selected menu.

Added An option to disable opening selected item on TC by double click. (add DoubleClickON=0 under an editor section)

Added Extended Commands Editor: Don't save "Usercmd.ini" or "Wcmd_xxx.ini" if it hasn't changed.

Fixed Extended Commands Editor: The program cannot properly read/write files contains a lot of commands. (e.g. 2500 commands or more)

Version 6.00 --- 3 March, 2011

Added Update Wincmd.ini ShortcutsWin section when exporting to Totalcmd.inc file.

Added Support Wcmd_*.inc in UTF-8 format with or without BOM.

Added Speed startup by loading files icon and property on demand, that is when expanding the menu containing them.

Added Start/Directory Menu Editor: Speed saving by using the API function "WritePrivateProfileSection". (speed is recognizable if the menu contains more than 200 items)

Added Directory Menu Editor: parameters list and window state can be shown by adding ShowParamList=1 under [DirectoryMenuEditor] section in "ultra tc editors.ini"

Added Extended Commands Editor: Show item's icon from the "Icon file" field instead of "Command" field.

Added Extended Commands Editor: If the "Icon file" field is empty then show icons from the last selected file instead of an error message.

Added Enhancement Parameters list editor.

Added Parameters list can be shown as a window instead of standard menu.

Added Support using spaces in the user-defined parameter.

Added Right click on the toolbar, shows a new dialog for customizing the toolbar.

Added Enhancement to auto scrolling the tree while dragging.

Added New buttons added to the toolbar "Find", "Move Up", "Move Down" and "Move To".

Added Close the program by pressing ESC. (can be enabled via CloseOnEsc=1 under [Common] section in "ultra tc editors.ini")

Added Restart TC function restarts TC with the last visited path of the active tab if this tab is "Locked, but directory changes allowed".

Fixed A command could be lost when switching between the program modes if that command refers to an exe file doesn't contain icon resource. (this bug was occurring ONLY if the option "Show file icon" was enabled)

Fixed Totalcmd.inc was not translated if "WCMD_xxx.INC" and "WCMD_xxx.MNU" are not using the same name, e.g. "WCMD_RUS.INC" and "WCMD_RUS_EXT.MNU".

Version 5.54 --- 12 October, 2009

Added Parameters list: show check mark beside items used in the parameters field.

Fixed Find dialog remains using previous language interface if the program language changed while it is visible.

Changed Remove nag screen, the program now is freeware.

Version 5.53 --- 17 August 2008

Added New parameter %A added to the default parameters list.

Fixed Cannot delete any item refer to non exist extended command.

Fixed Windows Vista: Vertical scroll bar in the menu panel was partially visible.

Version 5.52 --- 24 March 2008

Added Extended Command Editor: Auto rename command title if it is already exist.

Added New command Check Mnemonics added to File menu.

Added Warning message popup if duplicate mnemonic have found while editing command title.

Added Sort method ignores ampersand character '&' if it is exist in the menu title.

Added Sort method ignores separator items.

Added Move To dialog box: press Ctrl+Enter to move commands and submenus under the menu not the menu itself.

Fixed Leading whitespaces are removed from command title after saving.

Version 5.51 --- 24 July, 2007

Fixed Cannot use language file if the program start from a removable or network disk.

Version 5.50 --- 12 July, 2007

Added New mode for editing TC extended commands.

Added Update [Alias] section when exporting start menu entries to Totalcmd.inc file.

Added Support Total Commander 7.0 redirect feature.

Added Recognize Total Commander internal commands with parameters e.g. OpenTabs, LoadSearch.

Added New shortcuts F9, F10, F11 and F12 for Browse for file, Browse for folder, Choose internal command and Show parameters menu respectively.

Added Press Ctrl while dropping files to insert cd command in front of file name.

Added Use the program main window font settings in Edit Parameters List dialog box.

Added Apply Windows XP style to the program.

Version 5.14 --- 29 June, 2006

Added New commands "Sort All Menus" and "Sort Selected Menu" added to Edit menu.

Added Enhancement for Total Commander internal command drop down list.

Added New shortcuts Ctrl+F1/Ctrl+F2 for Expand Tree/Collapse Tree commands on View menu.

Changed Don't accept entering item title with only spaces in it.

Version 5.12 --- 4 September, 2005

Added New button "Clear List" added to Find dialog box.

Added Support using variable path "utceditors:\" instead of the program real path.

Added Press Esc key to close Find dialog box.

Fixed Wincmd.ini [Shortcuts] section was not updated if commands under it was saved as 'Decimal' or 'Hexadecimal'.

Version 5.10 --- 20 June, 2005

Added New function "Find".

Added Update wincmd.ini [Shortcuts] section while exporting start menu to Totalcmd.inc file.

Added New commands added to Edit menu 'Move Up', 'Move Down' and 'Move To...'.

Added Mark unused shortcuts in the shortcut list by 'x' icon. (Start Menu Editor)

Added New option "Search for the existence of files or folders on removable drives."

Added When exporting to Totalcmd.inc file the commands are added at their original position not at the end of file.

Added New shortcut <F2> for rename selected item.

Added New shortcut <Alt+Enter> for selected file or folder properties.

Added New shortcut <Enter> for Open in TC function.

Fixed Drag and drop a menu command to immediately next one has no effect (top to down).

Fixed Choose font dialog box wasn't pre-select current font size.

Changed When selecting internal command or typing in command field, pressing <Enter> key required to apply change.

Version 5.02 --- 10 April, 2005

Added Program settings file "ultra tc editors.ini" path and name can be customized.

Fixed When "Show File Icon" option is active, all program entries takes icon of the first program entry. (occurs only under localized Windows)

Fixed Start menu entries was not exported correctly if it exported without showing "Export to Totalcmd.inc" dialog box.

Fixed Minor bugs fixed.

Version 5.01 --- 28 March, 2005

Fixed Entry refer to file system plugin were appear as broken link (e.g. cd \\\UnInstaller)

Fixed Entry start with quotation (e.g. cd "C:\Program Files") were appear as broken link.

Fixed Very special bug was prevent reading the menu if the first entry under [DirMenu] or [User] section was "menu1=--".

Fixed Default Wincmd.ini file always added at the top of recent files list.

Version 5.00 --- 15 March, 2005

Added Support Drag & Drop files or folders from Total Commander, Windows Explorer or any other application to menu tree or to the 'Command' field.

Added New function "Open in TC".

Added New function "Always on Top".

Added New function "Restart Total Commander".

Added Recognize direct URL commands, So it doesn't appear with broken link symbol. e.g. http://www.ghisler.com.

Added Some new features added to "Export To Totalcmd.inc" dialog box.

Added Change the program language without restarting it.

Added Localize predefined parameters list.

Fixed If command parameters enclosed between quotation mark " ", this quotation mark was deleted when reopen the file again.

Fixed a file without extension was not added while the option 'Remove file extension' is checked.

Fixed Minor bugs fixed.

Changed Twice click on a menu tree item to inplace rename instead of one click.

Version 4.00 --- 9 September, 2004

Fixed Minor bugs fixed.

Changed The program become one of Ultra TC Editors package.

Version 3.02 --- 25 July, 2004

Added Recognize commands start with system environment variable e.g.

  • cd %commander_path%
  • %commander_path%\Wincmd.exe
  • cd %windir%
  • %windir%\notepad.exe
  • cd %temp%

Added New two functions "Import..." and "Export..."

Added New option [Search for the existence of files or folders on the network places.] useful if the program start slowly due to searching for those files

Added Switch to the next menu command when pressing Enter key inside Command, Parameters and Start Path fields. (useful when editing these fields by hand.)

Added Save button enabled only when the menu changed.

Fixed When opening a file from "Recent Files" list the name of this file was not appear in the program title bar.

Version 3.01 --- 26 June, 2004

Fixed When using local language some program user interface doesn't appear in this language.

Version 3.00 --- 24 June, 2004

Added Ultra TC Directory Menu Editor integrated with Ultra TC Start Menu Editor so you can edit the both menu within the same program.

Added Localization, the program comes with English language file you can translate this file to your language and use it.

Added a dialog box for Export To Totalcmd.inc function.

Added Recent files list added to the program File menu and to toolbar Open button.

Added The repeated command warning message show the name of the menu where the command you try to add is exist.

Version 2.21 --- 17 May, 2004

Added Search for any external command without path entry (e.g. Notepad.exe or even Notepad) in system path variable, so that it is appear in actual icon if it is exist.

Added New command 'Add Me' to add a link to the program at the end of the start menu.

Version 2.20 --- 15 May, 2004

Added New option 'Show File Icon' This option will extract the icon from the file and use it. (like explorer)

Added New option 'Automatically Create a New Command or Select the Next One.' This option will make creating your Start Menu extremely easy task.

Added The button beside Command field has a drop down menu command to easily browse for folder instead of pressing Ctrl.

Added New symbol 'Star' for the commands that refer to a folder link e.g. cd C:\Windows

Added 'All Files (*.*)' filter added to open Wincmd.ini dialog box.

Added The counter after the default name of New Command will indicate the number of commands currently in the start menu.

Fixed The text foreground and background color was not set when the program start.

Version 2.11 --- 09 May, 2004

Added The commands drop down list is automatically refreshed after exporting to (Totalcmd.inc) file.

Fixed The program was hang if (Wincmd.ini) file is hidden.

Fixed The program was hang if the registry value that refer to (Wincmd.ini) file isn't exist.

Fixed If the program didn't found (Wincmd.ini) and asked you to browse for it, each time you start the program and make changes these changes was not saved.

Fixed Always ask for (Totalcmd.inc) file path if this file is hidden.

Fixed Any command refer to a hidden file appear in question symbol also this file is exist.

Fixed Properties command doesn't work correctly if the menu item command refer to a hidden file.

Fixed Properties command doesn't work correctly if the menu item command refer to a folder. e.g. cd C:\Windows

Version 2.10 --- 04 May, 2004

Added Support Russian language and other languages.

Added New command 'Export To Totalcmd.inc' to create the cm_usermenu## entries into Totalcmd.inc file according to the Start Menu structure.

Added Parameters list editor.

Added New option to set the font of the command property fields to the current font settings.

Added Press Control key while pressing Open button beside command field to browse for folder.

Added A warning message appear when you try to add a command that already exist in your menu.

Fixed some command refer to a folder path appear in question symbol also this folder is exist.

Fixed if you navigate through the menu without making any change you were asked to Save changes when exit the program.

Changed The "Add Command" shortcut changed from [CTRL+V] to [CTRL+W] to solve the conflict with standard Paste shortcut [CTRL+V].

Changed The "Add Separator" shortcut changed from [CTRL+H] to [CTRL+L] to solve the conflict with Treeview, Listview and Text controls Backspace shortcut [CTRL+H].

Version 2.00 --- 19 April, 2004

  • First release.


Ultra TC Directory Menu Editor logo

Ultra TC Directory Menu Editor is a powerful tool which allows you to edit Total Commander directory menu. It is similar to Total Commander built-in editor but with more functions, more easily and fast.

Directory Menu Editor screen shoot

Read more about the program Menus and Options.


Ultra TC Extended Commands Editor logo

Ultra TC Extended Commands Editor is a powerful tool which allows you to edit Total Commander extended commands. It is similar to Total Commander built-in editor but with more functions, more easily and fast.

Extended Commands Editor screen shoot

Read more about the program Menus and Options.


Ultra TC Button Bar Editor logo

Ultra TC Button Bar Editor is a powerful tool which allows you to edit Total Commander main button bar and all sub-button bars simultaneously.

The program shows the button bar in two different panels:

  • Tree panel: Shows Total Commander main button bar and all sub-bars in hierarchical display.
  • Button bar panel: Shows only one button bar at a time with the ability to show another button bar by double click on its button.

Button Bar Editor screen shoot


File Menu Commands

Open...

Opens an existing Total Commander button bar file or creates a new button bar file by entering non existing file name in the Open file dialog box.

Keyboard shortcut: | Ctrl+O
Toolbar button: | toolbar icon

Save

Saves changes you already did to the button bar. This button will be disabled after saving and enabled again when there is any change.

Keyboard shortcut: | Ctrl+S
Toolbar button: | toolbar icon

Save and Restart Total Commander

Saves changes and restarts Total Commander if it is running, useful to make Total Commander reload the button bar with changes you already did.

Keyboard shortcut: Ctrl+Q

Import...

Opens an existing Total Commander button bar file and import its contents. The imported file contents will be appended to the end of current button bar file.

Keyboard shortcut: Ctrl+I

Recent Files

Displays the most recently used files to quickly open one of them.

Exit

Closes the current file and quits the program. If you try to quit before saving changes to your work, you'll be prompted to save your work first.


Edit Menu Commands

Add Button

Adds a new button after the selected button.

Keyboard shortcut: | Ctrl+W
Toolbar button: | toolbar icon

Add Sub-bar

Displays Open file dialog box to open an existing button bar file or creates a new button bar file by entering non existing file name.

Keyboard shortcut: | Ctrl+G
Toolbar button: | toolbar icon

Add Separator

Adds a separator line after the selected button.

Keyboard shortcut: | Ctrl+L
Toolbar button: | toolbar icon

Add Line Break

Adds a line break after the selected button.

Keyboard shortcut: | Ctrl+B
Toolbar button: | toolbar icon

Add Me

Adds a link to the program at the end of your main button bar.

Cut

Deletes the selected button and places its data on the Windows clipboard.

Keyboard shortcut: Ctrl+X

Copy

Places the selected button data on the Windows clipboard.

Keyboard shortcut: Ctrl+C

Paste

Creates a new button and reads its properties from the Windows clipboard.

Keyboard shortcut: Ctrl+V

Move Up

Moves the selected button one place up/left.

Keyboard shortcut: | Ctrl+U / Ctrl+Up or Left arrow / Shift+Up or Left
Toolbar button: | toolbar icon

Move Down

Moves the selected button one place down/right.

Keyboard shortcut: | Ctrl+Y / Ctrl+Down or Right arrow / Shift+Down or Right arrow
Toolbar button: | toolbar icon

Move To...

Displays "Move to" dialog box.

Keyboard shortcut: | Ctrl+T
Toolbar button: | toolbar icon

Open in TC

Opens the selected button path (if it is refer to an existing file or folder) in Total Commander left panel.
To configure this command, read this hint.

Keyboard shortcut: F8 / Enter

Delete

Deletes the selected button.

Keyboard shortcut: | DEL
Toolbar button: | toolbar icon

Rename

Renames the selected button.

Keyboard shortcut: | Ctrl+R / F2
Toolbar button: | toolbar icon

Properties

Displays the standard Windows property sheet for the selected button if it is refer to an exist file or folder.

Keyboard shortcut: Ctrl+P / Alt+Enter


Search Menu Commands

Find...

Displays Find dialog box for searching the button bar file(s) for the specified text. The search is performed from the first item to the last item. If the string is not found or if there isn't anymore occurrence of the text the message "Cannot find ......" is displayed.

Keyboard shortcut: | Ctrl+F
Toolbar button: | toolbar icon

Find dialog box

Start Menu Editor Find box

Options

  • Title: search specified text in the button tooltip.
  • Path: search specified text in the button command path.
  • Match whole word only: This option allows the search to be restricted to whole words only. This is useful to make searching more specific.
  • Clear List: Click this button to delete all previous search text.

Find Next

Repeats the previous Find command, the next occurrence of the find text will be found (if present) or the message "Cannot find ......" is displayed.

Keyboard shortcut: F3


View Menu Commands

Toolbar

Shows or Hides the Toolbar, which includes buttons for some of the most common commands, such as File Save. A check mark appears next to the menu item when the Toolbar is displayed.

To customize the toolbar, right click on it and execute "Customize..." command. Customize toolbar dialog will popup.

Always on Top

Places the program window above all other program windows running in your system. This command is useful when dragging items from other programs like Total Commander or Windows Explorer.

Button Bar

Shows or hides the button bar panel.

Button Bar Tree

Shows or hides the button bar tree panel.

Button Bar Options

Shows or hides Total Commander button bar options.

Expand Tree

Unfolds all sub-bar files in the tree.

Keyboard shortcut: Ctrl+F1

Collapse Tree

Folds all sub-bar files in the tree.

Keyboard shortcut: Ctrl+F2

Options...

Displays the program options dialog box.

Toolbar button: toolbar icon


Layout Tab Options

Button Bar Editor Layout tab options

check box Show tree icons

Displays or hides the tree icons.

check box Show tree lines

Displays or hides the lines between the tree items.

check box Show grid lines

Displays or hides the command list grid lines. (Choose Command dialog box)

check box Fixed borders

Displays or hides a thin border around the window panels.

check box Flat user interface

Displays or hides the 3D effects.

check box Show file icon

If checked then each button will appear with the icon specified in its Icon file field.


Icons Tab Options

Button Bar Editor Icons tab options

check box Use default icons

Displays the program default icons.

To use your won icons

  1. Clear the option Use default icons.
  2. Select the icon you want to change it.
  3. Double click the selected icon or click the Change... button to browse for new icon file.
  4. Repeat step 2 and step 3 for each icon you want to change.

Tree icons size:

Displays the tree icons in different sizes.

Button bar icons size:

Displays the button bar panel icons in different sizes.


Color and Font Tab Options

Button Bar Editor Color and Font tab options

check box Apply font settings to command property fields

If checked then the command property fields will take the menu tree font settings.

To change any color, click it and select another color from the choose color dialog box.

To change the program font, click the Change... button and select another font.

Note

If your language characters doesn't appear correctly, select your language Character set (Script) from the Font dialog box.


Operation Tab Options

Button Bar Editor Operation tab options

check box Automatically use command as item title

Specifies whether the program should automatically extract file or folder name and assign it for title of the selected item.

check box Remove file extension from item title

Specifies whether the program should automatically remove file extension from title of the selected item.

check box Automatically create new command or select next one

Specifies whether the program should automatically select next item after changing current item or create new item if current item is the last one.

check box Search for existence of files or folders on network places

Specifies whether the program should search for files or folders on the network places.

check box Search for existence of files or folders on removable drives

Specifies whether the program should search for files or folders on removable drives like floppy disk or CD-Rom.

check box Auto restart Total Commander after saving changes

Specifies whether the program should automatically restart Total Commander each time you save changes to the current file.


Language Tab Options

Button Bar Editor Language tab options

radio box Use default language

If selected, the program interface language will be English.

radio box Other:

If selected, the program will load the interface language from the specified file.

To change the program language:

  1. Select the option Other.
  2. Click the '>>' button and select your language file.


Parameters list

Overview

Parameters list provides speed access to all of Total Commander special parameters. To display the parameters list click the percent button Percent button beside the Parameters text box.

When you click the percent button, a predefined list of all available parameters will appear to select what you want.

To edit the parameters list, click on the drop down arrow beside the percent button and select the Edit... command.

To show the parameters list as a menu instead of window, click on the drop down arrow beside the percent button and select Show as menu option .

Edit Parameters List window

Edit parameters list window

Options:

check box Default

Switches between the default parameters list and user-defined list.

Buttons:

  • toolbar icon Moves the selected parameter one place up. (shortcut Ctrl+Up)
  • toolbar icon Moves the selected parameter one place down. (shortcut Ctrl+Down)
  • toolbar icon Adds a new parameter just under the selected item. (shortcut Ctrl+N)
  • toolbar icon Adds a separator just under the selected item. (shortcut Ctrl+L)
  • toolbar icon Deletes the selected parameter. (shortcut Del)
  • toolbar icon Edits the selected parameter. (shortcut F2/ double click)
  • OK: closes the dialog box and saves any changes you have made.
  • Cancel: closes the dialog box without saving any changes you have made.

Notes:

  • You can add multi parameters in one line, e.g. %P%N inserts file name with full path.
  • When the parameters list shown as a window, right click on a parameter will pass it to the main window without closing the parameters window.
  • Parameters already exist in the parameters field will be bold and red (window mode) or checked (menu mode).


Hints and Tips

Tip If the option "Show file icon" isn't selected then any command in the button bar can appear with one of the following symbols:

  • Checked symbol Checked symbol if the command is one of Total Commander internal commands.
  • Run symbol Run symbol if the command is refer to an existence file.
  • Star symbol Star symbol if the command is refer to an existence folder.
  • Question symbol Question symbol if the command is refer to a broken link to file or folder.

Tip To apply changes you have made in Total Commander button bar, save these changes and do one of the following:

  • On Total Commander configuration menu click Button Bar... and when the Change button bar dialog box appear, click OK button immediately.
  • Restart Total Commander.
  • Start another copy of Total Commander.
  • Execute built-in function Save and Restart Total Commander.

Tip Drag and Drop tips

  • To add a button into a sub-bar when it is collapsed, wait about second and half until the sub-bar expand.
  • You can drag any object refer to system file or folder from any other application which supports drag & drop (e.g. Total Commander, Windows Explorer, Windows Desktop or even shortcut from Windows Start menu).
  • You can drag any file or folder to desired button bar. (you can drag more than one file, folder or both file and folder together)
  • You can drag file or folder to 'Command' field to change the selected button command.
  • You can drag a file or folder to 'Start Path' field. (if you drop a file here the parent folder will be taken)
  • You can drag a file or folder to 'Parameters :' field.
  • Press Ctrl while dropping files to insert cd command in front of file name.
    Note: cd <filename> work only with Total Commander 7.0 and later.

Tip You can change how "Open in TC" command on "Edit" menu passing selected item path to Total Commander as follow:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key OpenInTCParam under [ButtonBarEditor] section.
  3. Set the key OpenInTCParam value to any combination of the following Total Commander command line parameters
    /O, /N, /L, /R, /S, /T, (/P=R or /P=L), /D=<x>.
    (for more information about these parameters, read Total Commander help file.)

Example:

  • OpenInTCParam=/O /L
    Always passing selected item path to Total Commander left panel.
  • OpenInTCParam=/O /R
    Always passing selected item path to Total Commander right panel.
  • OpenInTCParam=/O /S (default)
    Always passing selected item path to Total Commander active panel.
  • OpenInTCParam=/O /S /T
    Always passing selected item path to Total Commander active panel in new tab.
  • OpenInTCParam=/N /P=R /L
    Opens a new Total Commander window, activate right panel and pass selected item path to left panel.

Notes:

  • If the item path refers to a file, the parent folder will passed.
    If you are using Total Commander 7.0 or higher, this file will be selected.
  • You can execute this command by three ways:
  1. From Edit menu
  2. Double click an item
  3. Press F8

Tip If you want one click to start inplace rename a tree item:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key OneClickToRenameItem under [Common] section.
  3. Set the key OneClickToRenameItem value to 1


Versions history

Legend

Added Added

Fixed Fixed

Changed Changed or Improved

Version 6.01 --- 20 July, 2011

Added Show list of files actually changed in the save changes warning message.

Added An option to disable opening selected item on TC by double click. (add DoubleClickON=0 under [ButtonBarEditor] section in "ultra tc editors.ini")

Added An option to disable the message which appear when opening a bar file different than TC's main bar file. (add ShowMainBarMsg=0 under [ButtonBarEditor] section in "ultra tc editors.ini" (press <Shift> key while openning a file to force showing the message))

Added An option to read all sub-bars on startup. (add ReadAllBarsOnStartup=1 under [ButtonBarEditor] section in "ultra tc editors.ini" )

Added Show sub-bar list as a window instead of standard menu. (can be disabled by adding ShowBarListAsMenu=1 under [ButtonBarEditor] section in "ultra tc editors.ini" )

Fixed The dialog Move To was not show deep nested bars.

Version 6.00 --- 3 March, 2011

  • First release.


History Editor logo

Ultra TC History Editor is a powerful tool which allows you to modify history sections in Total Commander configuration files (Wincmd.ini and Wcx_ftp.ini).
You can use this program to do the following tasks:

  • Import/Export any history section.
  • Delete the content of any history section.
  • Rearrange the content of any history section.
  • Add predefined items to some history sections.
  • Easily lock/unlock tabs.
  • Easily set your won caption for locked tabs.

History Editor screen shoot


File Menu Commands

Open...

Opens an existing Total Commander configuration files (Wincmd.ini and Wcx_ftp.ini).

Keyboard shortcut: | Ctrl+O
Toolbar button: | toolbar icon

Save

Saves changes to the current Total Commander configuration files. This button will be disabled after saving and enabled again when there is any change.

Keyboard shortcut: | Ctrl+S
Toolbar button: | toolbar icon

Save and Restart Total Commander

Saves changes and restarts Total Commander if it is running.

Keyboard shortcut: Ctrl+Q

Alert Total Commander will restart using settings in the files you are editing. Therefore, if these files aren't your default Wincmd.ini and Wcx_ftp.ini you may find some settings out of date.

Export...

Displays Export dialog box.

Keyboard shortcut: Ctrl+E

Import...

Displays Import dialog box.

Keyboard shortcut: Ctrl+I

Recent Files

Displays the most recently used files to quickly open one of them.

Exit

Closes the current file and quits the program. If you try to quit before saving changes to your work, you'll be prompted to save your work first.


Edit Menu Commands

Add Item

Adds an item to the selected section.

This command doesn't work with the following sections:

  • Load/Save
  • F2 Load/Save
  • Left Tabs
  • Right Tabs
Keyboard shortcut: | Ctrl+W
Toolbar button: | toolbar icon

Move Up

Moves the selected item one place up.

Keyboard shortcut: | Ctrl+U / Ctrl+Up arrow
Toolbar button: | toolbar icon

Move Down

Moves the selected item one place down.

Keyboard shortcut: | Ctrl+Y / Ctrl+Down arrow
Toolbar button: | toolbar icon

Delete

Deletes the selected item.

Keyboard shortcut: | DEL
Toolbar button: | toolbar icon

Delete All...

Displays Delete All dialog box.

Keyboard shortcut: | Shift+DEL / Ctrl+Shift+DEL
Toolbar button: | toolbar icon

Delete All dialog box

Use Delete All dialog box to delete entire section contents.

Check sections you want to delete its contents and then click 'OK' button.

Delete All dialog box

Options

  • Also delete locked tabs: if this option checked then all locked tabs will deleted from LeftTabs and/or RightTabs section.

Note

  • The current selected section will be auto checked when displaying 'Delete All' dialog box.
  • Shortcut Ctrl+Shift+Del shows 'Delete All' dialog box and restore previous selected sections.

Rename

Renames the selected item.

Keyboard shortcut: | Ctrl+R / F2
Toolbar button: | toolbar icon


Search Menu Commands

Find...

Displays Find dialog box for searching the selected section for the specified text. The search is performed from the first item to the last item. If the string is not found or if there isn't anymore occurrence of the text the message "Cannot find ......" is displayed.

Keyboard shortcut: | Ctrl+F
Toolbar button: | toolbar icon

Find dialog box

History Editor Find box

Options

  • Match whole word only: This option allows the search to be restricted to whole words only. This is useful to make searching more specific.
  • Clear List: Click this button to delete all previous search text.

Find Next

Repeats the previous Find command, the next occurrence of the find text will be found (if present) or the message "Cannot find ......" is displayed.

Keyboard shortcut: F3


View Menu Commands

Toolbar

Shows or Hides the Toolbar, which includes buttons for some of the most common commands, such as File Save. A check mark appears next to the menu item when the Toolbar is displayed.

To customize the toolbar, right click on it and execute "Customize..." command. Customize toolbar dialog will popup.

Vertical Panels

Shows the two panels windows side by side instead of above each other. A check mark appears next to the menu item when the two panels are side by side.

Options...

Displays the program options dialog box.

Toolbar button: toolbar icon


Layout Tab Options

History Editor Layout tab options

check box Show grid lines

Displays or hides the history list grid lines.

check box Fixed borders

Displays or hides a thin border around the window panels.

check box Flat user interface

Displays or hides the 3D effects.

Foreground

Click the color box to change the program text color.

Background

Click the color box to change the program text background color.

Locked tab

Click the color box to change the locked tabs color.

To change the program font, click the Change... button and select another font.


Operation Tab Options

History Editor Operation tab options

check box Auto restart Total Commander after saving changes

Specifies whether the program should automatically restart Total Commander each time you save changes to the current files.


Language Tab Options

History Editor Language tab options

radio box Use default language

If selected, the program interface language will be English.

radio box Other:

If selected, the program will load the interface language from the specified file.

To change the program language:

  1. Select the option Other.
  2. Click the '>>' button and select your language file.


Import and Export history sections

Import dialog box

Use Import dialog box to import the selected section(s) from another Total Commander configuration file (Wincmd.ini or Wcx_ftp.ini).

Check sections you want to import and then click Import... button to choose a file.

Import History dialog box

Export dialog box

Use Export dialog box to export the selected section(s) to another Total Commander configuration file (Wincmd.ini or Wcx_ftp.ini).

Check sections you want to export and then click Export... button to choose a file.

Export History dialog box

Notes

  • Empty sections will shown in gray text.
  • Exporting empty sections will delete the content of these sections (if they are exist) in the file you opened for export to it.


Hints and Tips

Tip History sections list

The following table describes Total Commander history sections in Wincmd.ini and Wcx_ftp.ini files and their display name in the program left panel.

Nr. | Display Name | Section Name
1 | section icon Command Line | [Command line history]
2 | section icon Selection | [Selection]
3 | section icon Search for: | [SearchName]
4 | section icon Search in: | [SearchIn]
5 | section icon Find text: | [SearchText]
6 | section icon Load/Save | [Searches]
7 | section icon Rename mask: | [RenameTemplates]
8 | section icon Rename Search for: | [RenameSearchFind]
9 | section icon Rename Replace with: | [RenameSearchReplace]
10 | section icon F2 Load/Save | [Rename]
11 | section icon Left Tabs | [LeftTabs]
12 | section icon Right Tabs | [RightTabs]
13 | section icon Left history | [LeftHistory]
14 | section icon Right history | [RightHistory]
15 | section icon New Directory | [MkDirHistory]
16 | section icon Synchronize Options | [SyncOptions]
17 | section icon Plugin Attributes | [AttrPlugin]
18 | section icon Split Sizes | [SplitPerFile]
19 | section icon FTP Old Connections | [OldConnections]

Tip Command Line Parameters:

Use command line parameters to clean Wincmd.ini and Wcx_ftp.ini silently without showing the program interface
History Editor.exe [/i=name.ini] [/f=name.ini] [/s={all | number; number; number}] [/b= name.ini] [/r] [/o]

  • /i Specify another Wincmd.ini file instead of the default one.
  • /f Specify another Wcx_ftp.ini file instead of the default one.
  • /s Specify the section number that you want to delete, this number refer to the section number as it is appear in the program left panel. (see above table)
    To delete all history sections at once use /s=all
  • /b Specify a file to backup history sections before deleting.
  • /o Overwrite the old history in the backup file.
  • /r Restart Total Commander if it is running.

Example:

  • History Editor.exe /s= 1;2;4;7;11;12

Run silently and delete [Command line history]; [Selection]; [SearchIn]; [RenameTemplates]; [LeftTabs] and [RightTabs] sections in the default Wincmd.ini file.

  • History Editor.exe /i=C:\Wincmd.ini /s= 1;2;4;7;11;12 /b= C:\TC_history_backup.ini

Run silently and delete [Command line history]; [Selection]; [SearchIn]; [RenameTemplates]; [LeftTabs] and [RightTabs] sections in C:\Wincmd.ini file and backup them to C:\TC_history_backup.ini file before deleting.

Tip You don't have to restart Total Commander to apply changes you did it in all sections except for the following sections:

  • section icon Command Line
  • section icon Left Tabs
  • section icon Right Tabs
  • section icon Left history
  • section icon Right history

Tip You cannot arrange items in the following two sections:

  • section icon Load/Save
  • section icon F2 Load/Save

This is because Total Commander shows the contents of these two sections as a sorted list.

Tip You cannot add new items to the following four sections:

  • section icon Load/Save
  • section icon F2 Load/Save
  • section icon Left Tabs
  • section icon Right Tabs

This is because there are many properties for each item under these sections you must set them using Total Commander.

Alert Be sure that Total Commander is not running while saving changes you did in the following three sections, otherwise you will lose these changes when you close Total Commander.

  • section icon Command Line
  • section icon Left Tabs
  • section icon Right Tabs
  • section icon Left history
  • section icon Right history

Tip The program will use a section icon for its contents, if you dislike this and want back to the old look:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key UseSectionIcon under [HistoryEditor] section.
  3. Set the key UseSectionIcon value to 0

Tip The program will accept to add up to only 20 items under a history section, to change this limit:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key MaxItems under [HistoryEditor] section.
  3. Set the key MaxItems value to your desired number.
Note: Total Commander will read the first 20 items only.

Tip The icon of the active tab will be dummy. If you delete the active tab, the first item will be set as active tab. (Active tab is the selected tab when you close Total Commander).

Tip Press Enter key after changing a tab caption to switch to the next tab.

Tip In the right panel, if you cannot see the whole item text, you can press Ctrl + Num+

Tip You can arrange the items in section by drag and drop or by toolbar buttons Up and Down.


Versions history

Legend

Added Added

Fixed Fixed

Changed Changed or Improved

Version 6.01 --- 20 July, 2011

Added Show file name actually changed in the save changes warning message.

Version 6.00 --- 3 March, 2011

Added Right click on the toolbar, shows a new dialog for customizing the toolbar.

Added New button "Find" added to the toolbar.

Added New icons.

Added Close the program by pressing ESC. (can be enabled via CloseOnEsc=1 under [Common] section in "ultra tc editors.ini")

Added Restart TC function restarts TC with the last visited path of the active tab if this tab is "Locked, but directory changes allowed".

Version 5.54 --- 12 October, 2009

Added New history section [OldConnections].

Fixed Error occurs while running in silent mode if the program main window closed maxmized.

Fixed Find dialog remains using previous language interface if the program language changed while it is visible.

Changed Remove nag screen, the program now is freeware.

Version 5.53 --- 17 August 2008

Fixed Windows Vista: Vertical scroll bar in the right panel was partially visible.

Version 5.52 --- 24 March 2008

Added Save checked sections in Delete All, Import and Export dialog boxes.

Added New shortcut Ctrl+Shift+Del, shows Delete All dialog box and restore previous selected sections.

Fixed Run time error occurs when starting the program in silent mode.

Version 5.51 --- 24 July, 2007

Fixed Cannot use language file if the program start from a removable or network disk.

Version 5.50 --- 12 July, 2007

Added Total Commander 7.0 new history sections added.

Added Support Total Commander 7.0 redirect feature.

Added Progress bar appear when importing, exporting, opening and saving.

Added Apply Windows XP style to the program.

Version 5.14 --- 29 June, 2006

Added New shortcuts Ctrl+Up/Ctrl+Down for Move Up/Move Down commands in Edit menu.

Added Press Esc key to close Import, Export and Delete All dialog boxes.

Version 5.12 --- 4 September, 2005

Added Command line parameters to clean history sections silently (without user interface).

Added New button "Clear List" added to Find dialog box.

Added Support using variable path "utceditors:\" instead of the program real path.

Added Press 'Esc' key to close Find dialog box.

Added New setting key added to the program section in the file "ultra tc editors.ini": MaxItems.

Version 5.10 --- 20 June, 2005

Added New function "Find".

Added New setting key added to the program section in the file "ultra tc editors.ini": CommandListFullRowSelect.

Fixed Choose font dialog box wasn't pre-select current font size.

Version 5.02 --- 10 April, 2005

Added Program settings file "ultra tc editors.ini" path and name can be customized.

Version 5.01 --- 28 March, 2005

Fixed Default Wincmd.ini file always added at the top of recent files list.

Version 5.00 --- 15 March, 2005

Added Support 'Total Commander 6.5' new features.

Added Two new history sections added "Rename Search for:", "Rename Replace with:"

Added New function "Restart Total Commander".

Added Splitter bar added. (to resize each panel to desired width)

Added Vertical and horizontal panel mode.

Added Recent files list.

Added Change the program language without restarting it.

Added New tweaks make the program run faster.

Fixed The program always ask for "Wincmd.ini" file at start up if doesn't get it from the registry.

Added In some special cases Left/Right Tabs lock tab setting was not read correctly.

Changed The program icon changed.

Version 4.00 --- 9 September, 2004

Added Automatically find Total Commander configuration file ("Wincmd.ini").

Added The program user interface is localizable.

Changed The program become one of Ultra TC Editors package.

Version 2.01 --- 19 July, 2004

Added Show section symbol in preview panel.

Added Press Enter key or Double click an item in preview panel switch to this item.

Added Right click section name to Import/Export this section directly without showing Import/Export dialog box.

Fixed fixed a bug: locked tab caption was deleted when using [Delete All] dialog box to delete left/right tab section without deleting locked tabs.

Added minor bugs fixed.

Version 2.00 --- 17 July, 2004

Added Import & Export functions added.

Added Delete all history with one click.

Added New panel to show all sections content.

Added Add Item function added.

Added Rename function added.

Changed The program name changed to be "History Editor" instead of "History Cleaner"

Version 2.00 --- 7 July, 2004

  • First release.


Ultra TC Configuration Editor logo

Ultra TC Configuration Editor is a powerful tool which works as a database for all Total Commander configuration keys. Each key has a full description taken from Total Commander help file. With this program you can open Total Commander configuration files "Wincmd.ini" and "Wcx_ftp.ini" to see which keys are present and which are not.

The program window is divided into three panels:

  • Category panel: Shows categories in the current data file, each category contains a group of Total Commander settings.
  • Key panel: Shows keys under the selected category.
  • Description panel: Shows the full description of the selected key.

Ultra TC Configuration Editor screen shoot


File Menu Commands

Open...

Opens an existing Total Commander configuration file you want to edit (Wincmd.ini) or (Wcx_ftp.ini).

Keyboard shortcut: | Ctrl+O
Toolbar button: | toolbar icon

Save

Saves changes to the current Total Commander configuration file. This button will be disabled after saving and enabled again when there is any change.

Keyboard shortcut: | Ctrl+S
Toolbar button: | toolbar icon

Save and Restart Total Commander

Saves changes and restarts Total Commander if it is running. You must restart Total Commander to make it recognize the new settings.

Keyboard shortcut: Ctrl+Q

Alert Total Commander will restart using settings in the files you are editing. Therefore, if these files aren't your default Wincmd.ini and Wcx_ftp.ini you may find some settings out of date.

Open Data File...

Opens an existing data file.

Save Data File

Saves changes to the current data file.

Export...

Displays Export dialog box.

Keyboard shortcut: Ctrl+E

Import...

Displays Import dialog box.

Keyboard shortcut: Ctrl+I

Recent Files

Displays the most recently used files to quickly open one of them.

Exit

Closes the current file and quits the program. If you try to quit before saving changes to your work, you'll be prompted to save your work first.


Edit Menu Commands

Undo

Reverses previous editing operation.

Keyboard shortcut: | Ctrl+Z
Toolbar button: | toolbar icon

Redo

Reverses the previous Undo if no other actions have occurred since the last Undo.

Keyboard shortcut: | Ctrl+Y
Toolbar button: | toolbar icon

Tip Undo / Redo commands works only with editing the key value not with editing the key description.

Edit Value

Changes the selected key value.

Keyboard shortcuts: | Ctrl+R / F2 / Enter
Toolbar button: | toolbar icon

Value = 1

Sets the selected key value to 1.

There are many of Total Commander configuration options are enabled by setting their values to 1, so this command is very useful to quickly enable these options.

Keyboard shortcut: Ctrl+W

Value = 0

Sets the selected key value to 0.

There are many of Total Commander configuration options are disabled by setting their values to 0, so this command is very useful to disable these options quickly.

Keyboard shortcut: Ctrl+D

Browse Value...

Displays the appropriate dialog box for the selected key e.g. if the selected key requires a file path, displays Browse For File dialog box; if the selected key requires color code, displays Choose Color dialog box, etc....

Keyboard shortcut: Ctrl+B

New Key...

Creats a new key in the selected category. This command is enabled only if the selected category refers to an entire section (category with the orange folder icon. Orange folder icon)

Rename...

Renames the selected key. This command is enabled only if the selected category refers to an entire section (category with the orange folder icon. Orange folder icon)

Data File

Submenu with the following commands:

Add Key...

Displays Add new data key dialog to add a new data key just after the selected one.

Keyboard shortcut: Shift+F4

Modify Key...

Displays Modify data key dialog to change the selected key attributes.

Keyboard shortcut: Ctrl+Shift+F4

Delete Key

Deletes the selected key from the data file.

Keyboard shortcut: Alt+Del

Tip These commands are not available if the current category refers to an entire section (category with the orange folder icon. Orange folder icon)

Comment

Comments the selected key in the current Total Commander configuration file.

Keyboard shortcut: Shift+DEL

Tip This command doesn't delete the key, but instead it is adding a comma ( , ) in front of it, so that it will be invisible from Total Commander. Useful to make Total Commander use the default value of the commented key without deleting it from the configuration file (Wincmd.ini) or (Wcx_ftp.ini).

Delete

Deletes the selected key from the current Total Commander configuration file.

Keyboard shortcut: | DEL
Toolbar button: | toolbar icon

Tip Right click on the toolbar Delete button to comment the selected key instead of deleting it.

This feature can be disabled by adding ToolbarIgnoreRightClick=1 to the program INI file "ultra tc editors.ini" under ConfigurationEditor section.


Search Menu Commands

Find...

Displays Find dialog box for searching the current data file for the specified text. The search is performed from the first key to the last key. If the string is not found or if there isn't anymore occurrence of the text the message "Cannot find ......" is displayed.

Keyboard shortcut: | Ctrl+F
Toolbar button: | toolbar icon

Find dialog box

Configuration Editor Find box

Options

  • Key name: search specified text in the keys name.
  • Key description: search specified text in the keys description.
  • Key value: search specified text in the keys value.
  • Match whole word only: This option allows the search to be restricted to whole words only. This is useful to make searching more specific.
  • Clear List: Click this button to delete all previous search text.

Find Next

Repeats the previous Find command, the next occurrence of the find text will be found (if present) or the message "Cannot find ......" is displayed.

Keyboard shortcut: F3

Tip Right click on the toolbar Find button to execute Find Next command.

This feature can be disabled by adding ToolbarIgnoreRightClick=1 to the program INI file "ultra tc editors.ini" under ConfigurationEditor section.


View Menu Commands

Toolbar

Shows or Hides the Toolbar, which includes buttons for some of the most common commands, such as File Save. A check mark appears next to the menu item when the Toolbar is displayed.

To customize the toolbar, right click on it and execute "Customize..." command. Customize toolbar dialog will popup.

Description

Shows or Hides the key description panel. A check mark appears next to the menu item when the description panel is displayed.

Status Bar

Shows or Hides the status bar. A check mark appears next to the menu item when the status bar is displayed.

All Keys

Shows all keys in the current data file.

Keyboard shortcut: | F5
Toolbar button: | toolbar icon

Active Keys

Shows keys that are exist in both the current data file and the current Total Commander configuration file.

Keyboard shortcut: | F6
Toolbar button: | toolbar icon

Inactive Keys

Shows keys that are exist in the current data file and not exist in the current Total Commander configuration file.

Keyboard shortcut: | F7
Toolbar button: | toolbar icon

Advanced Keys Only

Shows keys that you cannot set via Total Commander Options dialog box or any other one.

Keyboard shortcut: | F8
Toolbar button: | toolbar icon

Sorted List

Sorts the key list (right panel). A check mark appears next to the menu item when the list is sorted.

Branch View

Shows all keys in the current category and all sub-categories.

Toolbar button: toolbar icon

Options...

Displays the program options dialog box.

Toolbar button: toolbar icon


Favorites Menu Commands

Add to Favorites...

Adds the selected key to the favorite list.

Keyboard shortcut: Ctrl+T

Organize Favorites...

Displays Organize Favorites window.

Keyboard shortcut: Ctrl+M


Layout Tab Options

Configuration Editor Layout tab options

check box Show tree lines

Displays or hides the lines between the category tree items.

check box Show grid lines

Displays or hides configuration keys list grid lines.

check box Fixed borders

Displays or hides a thin border around the window panels.

check box Flat user interface

Displays or hides the 3D effects.

check box Show key value directly after key name

Specifies whether the program should display key value directly after key name or show it aligned with column.

check box Show default value for inactive key

Specifies whether the program should display default value for inactive key.

check box Show minimum version required to use the selected key

Displays or hides Total Commander minimum version required to use the selected key.


Icons Tab Options

Configuration Editor Icons tab options

check box Use default icons

Displays the program default icons.

To use your won icons

  1. Clear the option Use default icons.
  2. Click on the icon you want to change and browse for a new icon.
  3. Repeat step 2 for each icon you want to change.


Color and Font Tab Options

Configuration Editor Color and Font tab options

Text :

Foreground

Click the color box to change the program text color.

Background

Click the color box to change the program text background color.

Active key (Wincmd.ini)

Click the color box to change the active keys color for settings in Wincmd.ini file.

Active key (Wcx_ftp.ini)

Click the color box to change the active keys color for settings in Wcx_ftp.ini file.

Inactive key

Click the color box to change the inactive keys color.

Font :

Click Change... button to set the font properties for both category tree and key list.

Description :

Foreground

Click the color box to change the description text color.

Background

Click the color box to change the description text background color.

Tab width

Sets the tab width for the key description window.

Font :

Click Change... button to set the font properties for the description text.


Operation Tab Options

Configuration Editor Operation tab options

check box Auto select next key after editing selected key.

Specifies whether the program should automatically select the next key after editing the value of the current key.

check box Auto expand categories tree at start up

Specifies whether the program should automatically expand the categories tree when the program start or when opening another data file.

check box Auto restart Total Commander after saving changes

Specifies whether the program should automatically restart Total Commander each time you save changes to the current file.

check box Read keys listed in the data file only

Specifies whether the program should read keys listed in the data file only and ignore all categories refers to entire sections in Wincmd.ini and wcx_ftp.ini.

Number of spaces to indent data file:

Sets the number of spaces which indent each category in the data file, this value must range between 0 and 32.


Language Tab Options

Configuration Editor Language tab options

radio box Use default language

If selected, the program interface language will be English.

radio box Other:

If selected, the program will load the interface language from the specified file.

To change the program language:

  1. Select the option Other.
  2. Click the '>>' button and select your language file.


Favorites List

Overview

Favorites list provides speed access to many of Total Commander settings which you are changing frequently.

There are two ways to add an item to the favorite list:

  1. On the Favorites menu, click 'Add to Favorites...'.
  2. Drag any key from the program main window and Drop it into the favorite list. (if the Organize Favorites window is visible)

Organize Favorites window

Organize Favorites window.

Buttons

  • Delete: delete the selected item.
  • Definition: finds the selected item in the main program window.
  • Up: moves the selected item one place up.
  • Down: moves the selected item one place down.
  • Add Separator: adds a separator line just above the selected item.
  • Save: saves any changes you did to the favorite list.
  • Close: Closes the 'Organize Favorites' window. If you try to close it before saving changes, you'll be prompted to save your work first.

Notes

  • Favorite list can accept up to 99 entries.
  • Favorite items that are not existed in the current data file will be disabled. (shown in grayed color)
  • To rename an item in the favorite list, click it twice or press F2.
  • You can arrange favorite list items by Drag and Drop, also you can use keyboard shortcut Ctrl+Up and Ctrl+Down.
  • Double click on a favorite item finds it in the main program window (like Definition button).


Data File

The program includes ''English.cedf'' data file. It is containing all Total Commander settings and their description.

Data in this file are taken from Total Commander official help file.

You can use the default data file, and you can also create your won data file, you can edit this file to:

  • Add/Remove any key.
  • Add/Remove any category.
  • Move a key from a category to another one.

Data file update

You can always find the latest version of this data file here.

Data file structure

Configuration Editor data file is a simple XML file. It is consisting of the following elements:

<?xml version="1.0" encoding="utf-8"?>

This line specifies the declaration and encoding used in the file, here you can specify your local language page encoding.
You can specify UTF-8 or Unicode, but in this case the program will show only characters from your system's default language code page, all other characters from different code pages will be shown as a question mark '?', that's because Visual Basic 6 controls are not support UNICODE.

<ultra_tc_editors_data_file>

This is the root element of the data file. Only one root element allowed in XML file.

<main_category>

This is the top level element, the data file must contain at least one element of this type, more than one is allowed, but they should not nest.
It has one attribute 'title' which specifies the display name as it will appear in the program tree panel.
This element is shown in the program tree panel with the Total Commander icon. Total Commander icon

<category>

This element is a container for other elements <key> and <section>.
It has one attribute 'title' which specifies the display name as it will appear in the program tree panel.
This element is shown in the program tree panel with the yellow folder icon. Yellow folder icon

<key>

This element includes some required attributes about each individual Total Commander setting.
Each <key> element has the following attributes:

name

Specifies the name of the key.

file

Specifies the Total Commander configuration file where the key can be found.

Values:

  • Wincmd.ini
  • Wcx_ftp.ini

section

Specifies the name of the section where the key can be found.

Special case:

[%Screen_Resolution%] For loading screen resolution-dependent section e.g. [1024x768 (8x16)].
The program will resolve the actual section name according to your current screen resolution.

version

Specifies Total Commander minimum version required to use the key.

The value of this attribute will be shown on the status bar.

This attribute is optional.

default

Specifies the default value of the key.

This attribute is optional.

advanced

Specifies whether the key can be set via Total Commander Options dialog box or any other one. (Used by the option 'Advanced Keys Only' on the View menu.)

This attribute is optional.

Values:

  • Yes
  • Any other value will be considered No.

dialog

Specifies the appropriate dialog box that will popup when executing Browse Value... command on the Edit menu.

This attribute is optional.

Values:

  • Open File
Shows the system "Open" dialog.
  • Open Folder
Shows the system "Browse for Folder" dialog.
  • Color
Shows the system "Color" dialog.
  • Font
Shows the system "Font" dialog.
  • Bits Sum
Shows "Bits Sum" dialog box.
  • Icon Library Preview
Shows "Icon Library Preview" dialog box.
  • Dialogs List
Shows a menu contains a list of all available dialogs to choose from. Useful if the key requires different dialogs.

<section>

This element includes some required attributes about each individual section in Wincmd.ini or Wcx_ftp.ini.
This element shown in the program tree panel with the orange folder icon. Orange folder icon
Each <section> element has the following attributes:

title

Specifies the display name of the section as it will appear in the program tree panel.

name

Specifies the name of the section.

Special cases:

  • [%Connection_Name%]
For loading all predefined FTP connections in the Wcx_ftp.ini file.
  • [%Server_Type%]
For loading all predefined server types in the Wcx_ftp.ini file.
  • [%CustomFields_WFX%]
For loading all predefined custom column for file system plugins in the Wincmd.ini file.
  • [%Entire_File_Sections%]
For loading all sections as they are listed in Wincmd.ini or Wcx_ftp.ini file.

file

Specifies the name of the Total Commander configuration file where the section can be found.

Values:

  • Wincmd.ini
  • Wcx_ftp.ini

version

Specifies Total Commander minimum version required to use the section.

The value of this attribute will be shown on the status bar.

This attribute is optional.

dialog

 Same as dialog attribute of the <key> element.

This attribute is optional.

<description>

This element includes the description of its parent element <key> or <section>.

If <description> element is empty or not present, the program will show "Description not available!" in the description panel.

<separator>

This element used for inserting a separator line between categories.
It has one attribute 'title' which specifies the separator string.

Notes:

  • Element's names and attribute's names must be lowercase.
  • You can create any nested levels of <category> element.
  • You can add any comments to the data file, in this case comment lines must enclosed between <!-- and -->
  • When you edit the description inside the program press Ctrl+Tab to indent the description.
  • To view the contents of "English.cedf" file or any other data file as a web page, open it with any internet browser e.g. IE6+, Firefox or Opera.

Localize data file

To localize the file "English.cedf" follow these steps:

  1. Make a copy of the file "English.cedf" with another name, e.g. "My_data_file.cedf".
  2. Open "My_data_file.cedf" with Configuration Editor.
  3. Open Total Commander help file written in your language, if there isn't such file then you have to do the translation yourself.
  4. Go to the group "Configuration and switches" then select the topic "Ini file settings" or "wcx_ftp INI settings".
  5. Copy a key description, go to Configuration Editor window and select that key then paste its description in the description panel.
  6. Repeat step 5 until you finish then save changes.


Script File

Script is a plain text file containing commands to be executed by the program.

A complete list of available commands and their description is below.

Run script

There are two methods to run a script:

  • Use command line.
  • Save the script file with the extension .cesf so it is possible to execute it by double click on the file, in this case, the first Script in the file will be executed.

Variables

Wincmd

Specify another Wincmd.ini file instead of the default file.

Wcxftp

Specify another Wcx_ftp.ini file instead of the default file.

ImportWincmd

Specify Wincmd.ini file to import from it via Import command.

ImportWcxftp

Specify Wcx_ftp.ini file to import from it via Import command.

ExportWincmd

Specify Wincmd.ini file to export to it via Export command.

ExportWcxftp

Specify Wcx_ftp.ini file to export to it via Export command.

CommanderPath

Specify another Total Commander installation path instead of the default path.
This variable will override the environment variable "%Commander_Path%"

Notes:

  • All variables must declare using Dim
  • If these variables are declared at the top of the file then they will be public and used by all scripts in the file.
  • If they are declared inside a script then they will be private and used by that script only, they will also shadows the publics.
  • CommanderPath variable must declare before other variables if "%Commander_Path%" is part of their value.

Example:

Dim Wincmd = "path_of_wincmd.ini"

Dim Wcxftp = "path_of_Wcx_ftp.ini"

Dim CommanderPath = "C:\Totalcmd"

Commands

CloseTC

Closes the active Total Commander window.

RunTC Command line parameters

Run Total Commander from the path specified by the variable CommanderPath with configuration files specified by Wincmd and/or Wcxftp. If CommanderPath, Wincmd and Wcxftp are not declared then the default values will be used.

The part Command line parameters is optional. It is used to run Total Commander with extra command line parameters except /i and /f. For details about Total Commander command line parameters, read Total Commander help file.

Example:

RunTC /L="C:\some path" /R="D:\some path"

Sleep

Waits the specified amount of time (in milliseconds) before continuing.
This command can be used after the command CloseTC to ensure that Total Commander has been closed before start writing to Wincmd.ini and/or Wcx_ftp.ini.

Beep

Sounds a tone through the computer's speaker.

MsgBoxOK

Shows a message box with OK button.
The message must be in one line, to insert line break use \n.

MsgBoxYesNo

Shows a message box with Yes and No buttons, it can be used as a confirmation to execute a script or not.
The message must be in one line, to insert line break use \n.

Call

Transfers control to another script in the same file.

Set

Sets a new value for the specified key.

Example:

Set Wincmd.ini\Configuration\MainMenu = "%Commander_Path%\Language\Wcmd_Eng.mnu"
Set Wcx_ftp.ini\General\LogFile = "%Commander_Path%\tcftp.log"

Delete

Deletes the specified key or section.

Example:

// Delete keys
Delete Wincmd.ini\Configuration\MainMenu
Delete Wcx_ftp.ini\General\LogFile
// Delete sections
Delete Wincmd.ini\LeftHistory
Delete Wcx_ftp.ini\OldConnections

Comment

Comments the specified key. Useful to deactivate a key and preserve its value.

Example:

Comment Wincmd.ini\Configuration\MainMenu
Comment Wcx_ftp.ini\General\LogFile

Uncomment

Uncomments the specified key.

Example:

Uncomment Wincmd.ini\Configuration\MainMenu
Uncomment Wcx_ftp.ini\General\LogFile

Import

Imports the specified key or section from the files specified by the variable ImportWincmd and/or ImportWcxftp.

Example:

// Import keys
Import Wincmd.ini\Configuration\MainMenu
Import Wcx_ftp.ini\General\LogFile
// Import sections
Import Wincmd.ini\Configuration
Import Wcx_ftp.ini\General

Export

Exports the specified key or section to the files specified by the variable ExportWincmd and/or ExportWcxftp.

Example:

// Export keys
Export Wincmd.ini\Configuration\MainMenu
Export Wcx_ftp.ini\General\LogFile
// Export sections
Export Wincmd.ini\Configuration
Export Wcx_ftp.ini\General

End

Terminates the script immediately, all commands come after End command will not be executed.

Notes

  • All commands must enclosed between "Script script_name" and "End Script".
  • Rules for script names:
    • Must begin with a letter
    • Only the following letters are allowed A-Z, a-z, 0-9 and _
  • Commented lines must start with //
  • Configuration Editor has the following hotkeys which make writing script much easier:
    • Ctrl+C or Ctrl+Ins to copy the full path of the selected key.
    • Ctrl+Shift+C or Ctrl+Shift+Ins to copy the full path of all listed keys prefixed by the command Set.
    • Ctrl+Alt+C or Ctrl+Alt+Ins to copy the full path of all listed keys prefixed by the command Delete.

Samples

1. Delete History

// This script backup history sections then delete them.

Script Delete_History

// Ask a confirmation to continue. If No button pressed, the script will be terminated
MsgBoxYesNo "All history sections will be deleted.\n\nAre you sure?"
// Close the active Totalcmd Commander window
CloseTC
// Wait for one second
Sleep 1000
// Call the script "Backup_History" to backup history sections
Call Backup_History
// Delete history sections
Delete Wincmd.ini\Command line history
Delete Wincmd.ini\Selection
Delete Wincmd.ini\SearchName
Delete Wincmd.ini\SearchIn
Delete Wincmd.ini\SearchText
Delete Wincmd.ini\Searches
Delete Wincmd.ini\RenameTemplates
Delete Wincmd.ini\RenameSearchFind
Delete Wincmd.ini\RenameSearchReplace
Delete Wincmd.ini\Rename
Delete Wincmd.ini\LeftHistory
Delete Wincmd.ini\RightHistory
Delete Wincmd.ini\MkDirHistory
Delete Wincmd.ini\SyncOptions
Delete Wincmd.ini\AttrPlugin
Delete Wincmd.ini\SplitPerFile
Delete Wcx_ftp.ini\OldConnections
// Run Total Commander
RunTC

End Script

Script Backup_History

// Declare the variables ExportWincmd and ExportWcxftp to specify the backup files
Dim ExportWincmd = "%commander_path%\wincmd.bak"
Dim ExportWcxftp = "%commander_path%\wcx_ftp.bak"
// Export history sections
Export Wincmd.ini\Command line history
Export Wincmd.ini\Selection
Export Wincmd.ini\SearchName
Export Wincmd.ini\SearchIn
Export Wincmd.ini\SearchText
Export Wincmd.ini\Searches
Export Wincmd.ini\RenameTemplates
Export Wincmd.ini\RenameSearchFind
Export Wincmd.ini\RenameSearchReplace
Export Wincmd.ini\Rename
Export Wincmd.ini\LeftHistory
Export Wincmd.ini\RightHistory
Export Wincmd.ini\MkDirHistory
Export Wincmd.ini\SyncOptions
Export Wincmd.ini\AttrPlugin
Export Wincmd.ini\SplitPerFile
Export Wcx_ftp.ini\OldConnections

End Script

2. Import History

// This script restore history sections from backup files.

Script Import_History

// Declare the variables ImportWincmd and ImportWcxftp to specify the files contain the backup
Dim ImportWincmd = "%commander_path%\wincmd.bak"
Dim ImportWcxftp = "%commander_path%\wcx_ftp.bak"
// Close the active Totalcmd Commander window
CloseTC
// Wait for one second
Sleep 1000
// Import history sections
Import Wincmd.ini\Command line history
Import Wincmd.ini\Selection
Import Wincmd.ini\SearchName
Import Wincmd.ini\SearchIn
Import Wincmd.ini\SearchText
Import Wincmd.ini\Searches
Import Wincmd.ini\RenameTemplates
Import Wincmd.ini\RenameSearchFind
Import Wincmd.ini\RenameSearchReplace
Import Wincmd.ini\Rename
Import Wincmd.ini\LeftHistory
Import Wincmd.ini\RightHistory
Import Wincmd.ini\MkDirHistory
Import Wincmd.ini\SyncOptions
Import Wincmd.ini\AttrPlugin
Import Wincmd.ini\SplitPerFile
Import Wcx_ftp.ini\OldConnections
// Run Total Commander
RunTC

End Script

3. TC Like Console

// This script hides all Total Commander interface elements (main menu bar, buttonbar, status bar, etc...)
// It will not touch your default Wincmd.ini because it is creating a temporary Wincmd.ini file for demonstration purpose only.

Script TC_Like_Console

// Declare a private Wincmd file to use in this script only
Dim Wincmd = "%temp%\ultra_tc_editors_script_sample_wincmd.ini"

// Hide main menu bar
Call Create_Empty_File
Set Wincmd.ini\Configuration\MainMenu=%temp%\ultra_tc_editors_script_sample_empty_file.mnu
Set Wincmd.ini\Configuration\RestrictInterface=1

// Hide file icons
Set Wincmd.ini\Configuration\ShellExtIcons=0
Set Wincmd.ini\Configuration\Showicons=0

// Hide all layout elements
Set Wincmd.ini\Layout\ButtonBar=0
Set Wincmd.ini\Layout\DriveBar1=0
Set Wincmd.ini\Layout\DriveBar2=0
Set Wincmd.ini\Layout\DriveCombo=0
Set Wincmd.ini\Layout\DirectoryTabs=0
Set Wincmd.ini\Layout\CurDir=0
Set Wincmd.ini\Layout\BreadCrumbBar=0
Set Wincmd.ini\Layout\HistoryHotlistButtons=0
Set Wincmd.ini\Layout\TabHeader=0
Set Wincmd.ini\Layout\StatusBar=0
Set Wincmd.ini\Layout\CmdLine=0
Set Wincmd.ini\Layout\KeyButtons=0
Set Wincmd.ini\Configuration\DirBrackets=0
Set Wincmd.ini\Configuration\ShowParentDirInRoot=1
Set Wincmd.ini\Configuration\FirstTime=0

// Set position
Set Wincmd.ini\[%Screen_Resolution%]\Maximized=1
Set Wincmd.ini\[%Screen_Resolution%]\Divider=1000
Set Wincmd.ini\[%Screen_Resolution%]\Tabstops=269,283,365,176,408,93

// Set font
Set Wincmd.ini\[%Screen_Resolution%]\FontName=Courier New
Set Wincmd.ini\[%Screen_Resolution%]\FontSize=14
Set Wincmd.ini\[%Screen_Resolution%]\FontWeight=400

// Set colors
Set Wincmd.ini\Colors\ForeColor=$FFFFFF
Set Wincmd.ini\Colors\BackColor=$000000
set Wincmd.ini\Colors\InverseCursor=1

// Run TC using the private ini "%temp%\ultra_tc_editors_script_sample_wincmd.ini"
RunTC

End Script

Script Create_Empty_File

// This script work as follow:
// 1- Declare a private Wincmd file to use in this script only
// 2- Write a random key under a random section (just to create a file)
// 3- Delete the random section so that the file will be empty
// 4- The created empty file will be used by the caller script as a value for the key MainMenu to hide it.
Dim Wincmd =%temp%\ultra_tc_editors_script_sample_empty_file.mnu
Set Wincmd.ini\12\34=56
Delete Wincmd.ini\12

End Script


Import and Export settings

Import dialog box

Use Import dialog box to import keys under the selected categories from another Total Commander configuration file (Wincmd.ini or Wcx_ftp.ini).

Check categories you want to import and then click Import... button to choose files.

Import Settings dialog box

Options:

check box Active keys

If checked, all active keys will be imported.

check box Inactive keys

If checked, all inactive keys will be imported.

check box Exclude redirection keys (Recommended)

If checked, redirection settings ( RedirectSection and AlternateUserIni ) will be not imported.
This option is useful when importing from a file uses redirection while the current file isn't and vice versa.

Export dialog box

Use Export dialog box to export keys under the selected categories to another Total Commander configuration file (Wincmd.ini or Wcx_ftp.ini).

Check categories you want to export and then click Export... button to choose files.

Export Settings dialog box

Options:

check box Active keys

If checked, all active keys will be exported.

check box Inactive keys

If checked, all inactive keys will be exported.
Exporting inactive keys means that they will be be deleted from the target file if they are existed there.

check box Exclude redirection keys (Recommended)

If checked, redirection settings ( RedirectSection and AlternateUserIni ) will be not exported.
This option is useful when exporting to a file uses redirection while the current file isn't and vice versa.


Hints and Tips

Tip Command Line Parameters:

Configuration Editor can be called with one or more of the following command line parameters:
"Configuration Editor.exe" [/i=name.ini] [/f=name.ini][/tc=commandr_path] [/df=data_file.cedf] [/sf=script_file.cesf][/sn=script_name] [/c]

  • /i Specify Wincmd.ini file to open.
  • /f Specify Wcx_ftp.ini file to open.
  • /tc Specify another Total Commander installation folder. This parameter will override the environment variable %Commander_Path%.
  • /df Specify a data file to open.
  • /sf Specify a script file to run.
  • /sn Specify the name of the Script to be executed. This parameter is optional, if it is not existed then the first script in the file will be executed.
  • /c Specify whether "Configuration Editor" starts after executing the script.

Tip Click on the status bar data file field will popup a list of all data files in the program "Data Files" subfolder, if this folder not exists the program will search for data files in its folder.
Double click on the status bar data file field will show Open File dialog box.

Tip If you want Total Commander use its default value for any key without deleting it from Wincmd.ini or Wcx_ftp.ini, you can Comment this key by pressing Shift + Delete.

Tip The program comments a key by adding comma ',' at the front of its name instead of the standard character semicolon ';'. This is because the API function GetPrivateProfileSection (under NT-based systems) strips out all lines that starts with a semicolon. Therefore, any key commented by a semicolon will not be recognized by the program.

If you still want to use the semicolon for commenting the keys, do the following:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key CommentString under [ConfigurationEditor] section.
  3. Set the key CommentString value to ;

Tip By default Bits Sum dialog box shows only bit description, to change this:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key BitsSumOption under [ConfigurationEditor] section.
  3. Set the key BitsSumOption value to:
  • 1= Show bit value only.
  • 2= Show bit description only.
  • 3= Show both bit value and description.

Tip The program has a built-in list of Total Commander sections that are not redirected by default. To customize this list in case Total Commander changed it:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key TCSectionsNotRedirectedByDefault under [Common] section.
  3. Set the key TCSectionsNotRedirectedByDefault value to define the list.

The default value is TCSectionsNotRedirectedByDefault=[Configuration],[Layout],[Packer],[Confirmation],[Extensions],[Associations],[Shortcuts],[ShortcutsWin],[PackerPlugins],[FileSystemPlugins],[ListerPlugins],[ContentPlugins]

Important:

  • Change the list of Total Commander sections that are not redirected by default ONLY if Total Commander changed it.
  • The key TCSectionsNotRedirectedByDefault is common between all programs in Ultra TC Editors.


Versions history

Legend

Added Added

Fixed Fixed

Changed Changed or Improved

Version 6.01 --- 20 July, 2011

Added Show file name actually changed in the save changes warning message.

Fixed The program doesn't work properly if there is duplicate section name in Wincmd.ini and/or Wcx_ftp.ini file.

Version 6.00 --- 3 March, 2011

Added Change data file format to XML. (using XML make the program start very fast)

Added New navigation mode.

Added New command "Branch view" on "View" menu to disable the new navigation mode.

Added New command "Status Bar" on "View" menu to show or hide the status bar.

Added New dialog for Import and Export command.

Added New dialog for adding new key to the data file (use Shift+F4 to show it)

Added New dialog for modifying any key in the data file (use Ctrl+Shift+F4 to show it)

Added New function to delete a key from the data file (use Alt+Del to call it)

Added New columon "Section" added to the key list.

Added New button >> appears while editing a key has dialog attribute e.g "ForeColor" key.

Added Show Total Commander minimum required version for the selected key on the status bar. (optional)

Added Remember last selected key on colsing the program. (can be disabled by adding RememberLastKey=0 under [ConfigurationEditor] section in "ultra tc editors.ini")

Added Remember last selected key on opening another data file.

Added Close the program by pressing ESC. (can be enabled by adding CloseOnEsc=1 under [Common] section in "ultra tc editors.ini")

Added New icons.

Added New option to use different icons set instead of the program default icons.

Added Show icons in "Organize favorites" window.

Added When go to a favorite item, pre-select the category contains it.

Added When do search, pre-select the category contains the search result.

Added Change favorites saving format because it was not work under Win9x (old format will be converted automaticaly)

Added Right click on the toolbar, shows a new dialog for customizing the toolbar.

Added New command line parameters.

Added Run in silent mode and execut a script via command line.

Added New hotkeys Ctrl+C and Ctrl+Ins to copy the full path of the selected key to the clipboard. (useful for building scripts)

Added New hotkeys Ctrl+Shift+C and Ctrl+Shift+Ins to copy the full path of all listed keys to the clipboard prefixed by the command Set. (useful for building scripts)

Added New hotkeys Ctrl+Alt+C and Ctrl+Alt+Ins to copy the full path of all listed keys to the clipboard prefixed by the command Delete. (useful for building scripts)

Added When opening another Wincmd.ini via File> Open..., set the value of InstallDir in that file as %Commander_Path% (can be disabled by adding OverrideCommanderPath=0 under [Common] section in "ultra tc editors.ini")

Added Restart TC function restarts TC with the last visited path of the active tab if this tab is "Locked, but directory changes allowed".

Version 5.54 --- 12 October, 2009

Added Find button added to the toolbar.

Added Right click on the toolbar Delete button to comment the selected key instead of deleting it.

Added Update English and Russian data files to Total Commander 7.50.

Fixed Press Escape key while editing a value, cause beep sound.

Fixed Status bar always shows Wincmd.ini as target file for FTP settings.

Fixed Find dialog remains using previous language interface if the program language changed while it is visible.

Changed Remove nag screen, the program now is freeware.

Changed Reduce the program startup time.

Changed Display the full path of the current files in the title bar.

Version 5.53 --- 17 August 2008

Added Status bar shows if target section is redirected or not. (redirected section mark with ">>>")

Added Status bar shows actual TC ini file name.

Fixed If the option 'Read keys listed in the data file only' checked, some descriptions are lost after saving the data file.

Fixed Press Enter key after editing a value, cause beep sound.

Fixed Windows Vista: Vertical scroll bar in the right panel was partially visible.

Version 5.52 --- 24 March 2008

Added Bits Sum dialog box shows bit description instead of bit value.

Version 5.51 --- 24 July, 2007

Fixed Cannot use language file if the program start from a removable or network disk.

Fixed Overflow run-time error occurs at startup under some very specific conditions.

Changed Favorites list saving method changed to make it possible to have favorite key with the same name but under different section e.g. RedirectSection keys.

Version 5.50 --- 12 July, 2007

Added Support Total Commander 7.0 redirect feature.

Added The program can work with all sections in both Wincmd.ini and Wcx_ftp.ini files.

Added New dialog box Bits Sum to use with keys like DirTabOptions.

Added New dialog box Icon Library Preview to use with keys like IconLib.

Added New command "Advanced Keys Only" added to the program "View" menu.

Added New option "Key value" added to the Find dialog box.

Added Update English data files to Total Commander 7.0.

Added Apply Windows XP style to the program.

Fixed Commented keys was not recognized by the program. (under Windows XP/2000)

Version 5.14 --- 29 June, 2006

Added Edit both Wincmd.ini and Wcx_ftp.ini at the same time.

Added Click on status bar data file field, shows a list of files in the program "Data Files" subfolder.

Added Some new options added to the program "Options" dialog box.

Added New command "Sorted List" added to the program "View" menu.

Added New shortcuts in Organize Favorites window, Ctrl+Up/Ctrl+Down to move selected item Up/Down.

Added New shortcuts Ctrl+I/Ctrl+E for Import/Export on File menu.

Added Click on upper right color box, shows Choose color dialog box.

Fixed Error occurs when double click on the right panel while it is empty.

Changed Data files structure has been changed and improved.

Changed Command Value = 1 shortcut changed to Ctrl+W.

Version 5.12 --- 4 September, 2005

Added New button "Clear List" added to Find dialog box.

Added Support using variable path "utceditors:\" instead of the program real path.

Added Press 'Esc' key to close Find dialog box.

Version 5.10 --- 20 June, 2005

Added Adding favorite key to 'Organize Favorites' window using Drag & Drop.

Added Arrange favorites list using Drag & Drop.

Added Apply different font size for key description text box.

Added "Find" dialog box now has a history list store the last 20 searches.

Added Press 'Ctrl+Tab' or 'Shift+6' to indent key description.

Added New setting key added to the program section in the file "ultra tc editors.ini": CommandListFullRowSelect.

Added Data files updated.

Fixed Choose font dialog box wasn't pre-select current font size.

Fixed Error occurs when closing search dialog box by X button while it is not active.

Version 5.02 --- 10 April, 2005

Added Program settings file "ultra tc editors.ini" path and name can be customized.

Added "tc special keys xxx.cedf" updated to include all settings that you cannot set it via Total Commander dialog boxes.

Version 5.01 --- 28 March, 2005

Fixed Default Wincmd.ini file always added at the top of recent files list.

Version 5.00 --- 15 March, 2005

Added Associate Data Files with the program, so you can start the program by double click a data file you want to start with.

Added New function "Find".

Added New favorites list added.

Added New command "Comment" to disable a setting key by commenting it instead of deleting.

Added New function "Restart Total Commander".

Added New functions "Import" & "Export" the keys on selected category.

Added Splitter bars added. (to resize each panel to desired width)

Added Recent files list.

Added Double click on Status bar data file panel to change the current data file.

Added Press Enter to start editing a key value. (like double click or Ctrl+R)

Added Change the program language without restarting it.

Fixed Deleted keys were appear as active after saving the changes.

Changed The program icon changed.

Version 4.00 --- 9 September, 2004

Added The program user interface is localizable.

Added Russian and Germany data files included.

Fixed Minor bugs fixed.

Changed The program become one of Ultra TC Editors package.

Version 2.00 --- 14 August, 2004

Added Unlimited "Undo" and "Redo".

Added Ability to edit and save any key description inside the program.

Added Automatically find Total Commander configuration file ("Wincmd.ini").

Added New option "Auto select the next key after editing."

Added Double click a key to start editing its value.

Added When starting a key editing only the value is selected.

Added When you start editing an inactive key you will see the default value for this key.

Added 3 new command in Edit menu "Value = 0", "Value = 1" and "Browse Value".

Added 3 new command in View menu "All Keys", "Active Keys" and "Inactive Keys".

Fixed Keyboard context menu key is now working.

Changed Now you must press Enter key after editing a key value to accept it.

Version 1.00 --- 4 August, 2004

  • First release.


Hotkeys Editor logo

Ultra TC Hotkeys Editor is a powerful tool which allows you to modify Total Commander hotkeys and command aliases, it is include many features that will make assigning hotkeys and aliases very easy and fast.

Also you can use this program to do the following tasks:

  • Print default hotkeys list.
  • Print user-defined hotkeys list.
  • Print command aliases list.
  • Print all Total Commander internal commands list.
  • Update hotkeys in Total Commander main menu.

Hotkeys Editor screen shoot


File Menu Commands

Open...

Opens an existing Total Commander configuration file (Wincmd.ini) to edit its hotkeys.

Keyboard shortcut: | Ctrl+O
Toolbar button: | toolbar icon

Save

Saves changes to the current Total Commander configuration file.

Keyboard shortcut: | Ctrl+S
Toolbar button: | toolbar icon

Save and Restart Total Commander

Saves changes and restarts Total Commander if it is running. You must restart Total Commander to make it recognize the new settings.

Keyboard shortcut: Ctrl+Q

Alert Total Commander will restart using settings in the file you are editing, therefore if this file isn't your default Wincmd.ini you may find some settings out of date.

Export to Text File...

Displays Export to Text File dialog box.

Toolbar button: toolbar icon

Export To Main Menu...

Updates your default Total Commander main menu file according to the current hotkeys map.

Keyboard shortcut: | Ctrl+E
Toolbar button: | toolbar icon

Example:

If you have a command in your Total Commander main menu its caption is:

Copy Filename(s) to Clipboard Ctrl+Alt+C

and you changed the hotkey for this command to Ctrl+Shift+C then after exporting, its caption will changed to:

Copy Filename(s) to Clipboard Ctrl+Shift+C

also if you delete the hotkey for this command, it will deleted too from its caption and it will be:

Copy Filename(s) to Clipboard

Recent Files

Displays the most recently used files to quickly open one of them.

Exit

Closes the current file and quits the program. If you try to quit before saving changes to your work, you'll be prompted to save your work first.


Search Menu Commands

Find...

Displays Find dialog box for searching the command list for the specified text. The search is performed from the first item to the last item. If the string is not found or if there isn't anymore occurrence of the text the message "Cannot find ......" is displayed.

Keyboard shortcut: | Ctrl+F
Toolbar button: | toolbar icon

Find dialog box

Hotkeys Editor Find box

Options

  • Description: search specified text in the description column.
  • Command: search specified text in the command column.
  • Code: search specified text in the code column.
  • Default hotkey: search specified text in the default hotkey column.
  • User-defined hotkey: search specified text in the user-defined hotkey column.
  • Alias: search specified text in the alias column.
  • Match whole word only: This option allows the search to be restricted to whole words only. This is useful to make searching more specific.
  • Clear List: Click this button to delete all previous search text.

Find Next

Repeats the previous Find command, the next occurrence of the find text will be found (if present) or the message "Cannot find ......" is displayed.

Keyboard shortcut: F3

Tip Right click on the toolbar Find button to execute Find Next command.

This feature can be disabled by adding ToolbarIgnoreRightClick=1 to the program INI file "ultra tc editors.ini" under HotkeysEditor section.


View Menu Commands

Toolbar

Shows or Hides the Toolbar, which includes buttons for some of the most common commands, such as File Save. A check mark appears next to the menu item when the Toolbar is displayed.

To customize the toolbar, right click on it and execute "Customize..." command. Customize toolbar dialog will popup.

Category List

Shows or Hides the Totalcmd.inc file categories list. A check mark appears next to the menu item when the categories list is displayed.

Sorted List

Sorts the commands list. A check mark appears next to the menu item when the list is sorted.

Toolbar button: toolbar icon

The list includes the following six columns:

  • Description
  • Command
  • Code
  • Default Hotkey
  • User-defined Hotkey
  • Alias

To sort any column click its header. A small black arrow appear next to the sorted column shows you the sort order.

Options...

Displays the program options dialog box.

Toolbar button: toolbar icon


Layout Tab Options

Hotkeys Editor Layout tab options

check box Show grid lines

Displays or hides the hotkey list grid lines.

check box Fixed borders

Displays or hides a thin border around the window panels.

check box Flat user interface

Displays or hides the 3D effects.

check box Show save mode in save button

Displays or hides the current save mode character above the save button.

check box Show hotkeys in reverse order

Specifies whether the program should display hotkeys in reverse order, e.g. A + Ctrl instead of Ctrl + A.

check box Show icons for internal commands

Displays associated icon for Total Commander internal commands, these icons are stored in the file Wcmicons.dll or WcIconEx.dll.

Modifiers:

To change modifiers key sequence, arrange modifiers sequence list by drag and drop.

To change modifiers key separator, select your desired separator from the dropdown list.


Icons Tab Options

Hotkeys Editor Icons tab options

check box Use default icons

Displays the program default icons.

To use your won icons

  1. Clear the option Use default icons.
  2. Click on the icon you want to change and browse for a new icon.
  3. Repeat step 2 for each icon you want to change.


Color and Font Tab Options

Hotkeys Editor Editor Color and Font tab options

To change any color, click it and select another color from the choose color dialog box.

To change the program font, click the Change... button and select another font.

Note

If your language characters doesn't appear correctly, select your language Character set (Script) from the Font dialog box.


Operation Tab Options

Hotkeys Editor Operation tab options

check box Auto restart Total Commander after saving changes

Specifies whether the program should automatically restart Total Commander each time you save changes to the current file.

check box Auto select next command after editing selected command.

Specifies whether the program should automatically select the next command after assigning/deleting a hotkey or alias.

check box Always export to main menu file when saving

Specifies whether the program should exports the hotkeys to your Total Commander Main Menu file after saving without any prompt.

check box Always remind me to export the changes

Specifies whether the program should display Export to Main Menu dialog box each time you save changes.


Language Tab Options

Hotkeys Editor Language tab options

radio box Use default language

If selected, the program interface language will be English.

radio box Other:

If selected, the program will load the interface language from the specified file.

To change the program language:

  1. Select the option Other.
  2. Click the '>>' button and select your language file.


Hotkeys Printing

To print the Total Commander hotkeys list:

  1. On the File menu, click Export to Text File...
  2. In the Export to Text File dialog box, customize the exported list.
  3. Click Save button.
  4. After saving the file, it will be opened with the default application for text or web page files according to the save mode.
  5. On the File menu of the opened application, click Print...

Export to Text File dialog box

Export to Text File dialog box

Options

  • Description: if checked, the 'Description' column will added to the list.
  • Command: if checked, the 'Command' column will added to the list.
  • Code: if checked, the 'Code' column will added to the list.
  • Default hotkey: if checked, the 'Default Hotkey' column will added to the list.
  • User-defined hotkey: if checked, the 'User-defined Hotkey' column will added to the list.
  • Alias: if checked, the 'Alias' column will added to the list.
  • Export all commands: if checked then all commands in the list will added even if it hasn't hotkey. (useful to print all Total Commander internal commands)
  • Export as HTML code: if checked then the hotkeys list will saved as web page.
  • Add separator: if checked, a separator line will inserted between each command. The default character forms the separator is '-', you can use another character by typing it in the text field.
  • Preview font:: this is a dropdown list contain 4 predefined font names Courier New, Fixedsys, Terminal and the forth is the program main window font.

Notes

  • Preview text box shows only the first 50 lines of the text that will be exported to the text file.
  • To print a sorted list, return to the program main window and sort the commands.
  • To arrange the command list columns, return to the program main window and re-arrange the command list columns (by dragging the column header) and when you back, the preview text box will be updated.
  • If you used a text editor to print the file then for best printing results use a fixed width font e.g. Courier New, Fixedsys or Terminal font.


Exporting Hotkeys to Main Menu

If you want to update your Total Commander main menu with the latest hotkeys mapping, On the toolbar, click Export To Main Menu... button, the following dailog box will popup.

Export to Main Menu dialog box

Export to Main Menu dialog box

check box Default hotkey

If checked, the 'Default Hotkey' column will be exported.

check box User-defined hotkey

If checked, the 'User-defined Hotkey' column will be exported.

check box Alias

If checked, the 'Alias' column will be exported.

check box Remove spaces from hotkeys.

If checked, spaces inside hotkey will be removed.
If not checked, hotkey will be exported as it is appearing in the program main window.

check box Export redefined default hotkeys

If checked, the program will export default hotkey that has redefined to another command.

check box Mark redefined default hotkeys

If checked, the program will mark default hotkey that has redefined to another command by adding (*) at the end of it.

check box Export only first value in each column.

If checked, only first value in each column will be exported.

check box Export only one column for each command.

If checked, the program will export only one column for commands that has a value in each column, in this case you can select column priority from the drop down list.
If not checked, the program will export all columns for commands that have a value in each column, in this case you can select column sequence from the drop down list.

Alert If your default Total Commander main menu file is UTF-8 encoded, please backup it before exporting hotkeys because exporting to UTF-8 encoded file not always success for some languages, e.g. Chinese.
A warning message will popup before exporting hotkeys to UTF-8 encoded file. This warning message can be disabled by adding UTF8Warning=0 under [HotKeysEditor] section in "ultra tc editors.ini"

Important:
The warning message will not popup if you select a UTF-8 encoded file via Browse... button.


Data File

Hotkeys Editor include only one data file: tc default hotkeys.hky

This file contain all Total Commander default hotkeys.

Data file update

Hotkeys Editor data file will be updated when Total Commander change one of its default hotkeys or add new one.

You can always find the latest version of this data file here.

Data file structure

Hotkeys Editor data file has the following structure:

[TC Default Hotkeys] >> Must be present.

Internal_command_code = Hotkey

Or (if the command has two or more hotkey)

Internal_command_code = Hotkey 1= Hotkey 2


Hints and Tips

Tip The toolbar Save button has additional three commands (not included in the File menu) enable you to save the hotkeys in three modes.

Save button dropdown menu

  • Save Command As Text:
    e.g. CA+C=cm_CopyFullNamesToClip
  • Save Command As Decimal:
    e.g. CA+C=2018
  • Save Command As Hexadecimal:
    e.g. CA+C=$7E2

When you select one from this list it will be the default mode for Save button and you don't have to dropdown this list again. The save button will marked (optionally) with the save mode as follow:

  • Character T for text mode.
  • Character D for decimal mode.
  • Character H for hexadecimal mode.

Tip Beginning of version 5.50, the option Use ContextMenu key instead of Alt key has been removed from the options dialog box but you can still activate it manually as follow:

  1. Open the program INI file "ultra tc editors.ini"
  2. Create the key UseContextMenuKey under [HotkeysEditor] section, set its value to 1.

Tip Press Right Arrow key while the dropdown key list is activated to show a special window that contain all keys list but without scroll bar, So it is easily to select any key you want.

You can change this window height and width via KeysListHeight and KeysListWidth in the program INI file.

Tip You can customize the dropdown key list as follow:

  1. Open the program INI file "ultra tc editors.ini"
  2. Create the key KeysList under [HotkeysEditor] section, define your desired list.

The default value is:

KeysList=F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,F11,F12,
A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z,
0,1,2,3,4,5,6,7,8,9,Ins,Del,Home,End,
PgUp,PgDn,Space,Back,Tab,+,-,*,/,Enter,Esc,Left,Right,Up,Down,Pause,
OEM_,,OEM_.,OEM_+,OEM_-,OEM_<\>,OEM_US`~,OEM_US[{,OEM_US]},OEM_US\|,OEM_US;:,OEM_US'",OEM_US/?,OEM_FR!

Alert You are allowed to change keys sequence or letter case, but NEVER translating, deleting or adding new keys.

Tip Press Escape or Backspace to clear Control, Alt, Shift and Win checkboxes at once.

Tip Press Insert key instead of Enter to assign another hotkey or alias to the same command.

Tip Press Ctrl+Tab to switch between hotkey mode and alias mode.

Tip The default undefined hotkey string is "---", if you want to change this:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key UndefinedHotkey under [HotkeysEditor] section.
  3. Set the key UndefinedHotkey value to your desired string.
    (it must be at least one character but not space)

Tip The default multi hotkey separator string is "=", if you want to change this:

  1. Run any text editor program (e.g. Notepad) and open the program INI file "ultra tc editors.ini"
  2. Create the key MultiHotkeySeparator under [HotkeysEditor] section.
  3. Set the key MultiHotkeySeparator value to your desired string.
    (it must be at least one character but not space)

Alert Be sure that Start Menu Editor and Hotkeys Editor are not running at the same time, because when the two programs start, they read shared settings in Wincmd.ini file; therefore, changing these shared settings within one program, the other program will not recognize the changes and will continue using the old settings, which read it at start up and this could cause unpredicted errors.


Versions history

Legend

Added Added

Fixed Fixed

Changed Changed or Improved

Version 6.00 --- 3 March, 2011

Added Many optimizations to make the program starts much faster.

Added Support Wcmd_*.inc in UTF-8 format with or without BOM.

Added Support exporting hotkeys to a menu file saved in UTF-8 format.

Added Show icons of TC internal commands from the file WcmIcons.dll or WcIconEx.dll

Added Right click on the toolbar, shows a new dialog for customizing the toolbar.

Added New icons.

Added New option to use different icons set instead of the program default icons.

Added New color options for "Command with hotkey" and "Command without hotkey"

Added New button "Find" added to the toolbar.

Added Close the program by pressing ESC. (can be enabled via CloseOnEsc=1 under [Common] section in "ultra tc editors.ini")

Added Restart TC function restarts TC with the last visited path of the active tab if this tab is "Locked, but directory changes allowed".

Fixed Totalcmd.inc was not translated if "WCMD_xxx.INC" and "WCMD_xxx.MNU" are not using the same name, e.g. "WCMD_RUS.INC" and "WCMD_RUS_EXT.MNU".

Version 5.54 --- 12 October, 2009

Added Support new modifier Win used in Total Commander 7.50.

Changed Remove nag screen, the program now is freeware.

Version 5.53 --- 17 August 2008

Fixed Windows Vista: Vertical scroll bar in the right panel was partially visible.

Changed The program icon changed.

Version 5.52 --- 24 March 2008

Fixed Cannot switch between Hotkeys and Alias mode after hiding category list while the selected category isn't [All] category.

Version 5.51 --- 24 July, 2007

Fixed Cannot use language file if the program start from a removable or network disk.

Version 5.50 --- 12 July, 2007

Added New panel for Totalcmd.inc categories.

Added Auto translate Totalcmd.inc file if the translation file exist.

Added Show extended command in both usercmd.ini and wcmd_xxx.ini.

Added New dialog box 'Export to Main Menu'.

Added New option 'Auto select next command after pressing Enter'.

Added Hotkeys list can be printed as web page.

Added Apply Windows XP style to the program.

Added Support Total Commander 7.0 Alias feature.

Added Support Total Commander 7.0 redirect feature.

Fixed The program always steal the focus when using Alt+Tab to switch between applications.

Changed "Export To Clipboard" dialog box changed to "Export To Text File"

Version 5.14 --- 29 June, 2006

Added Right click on the command list, popup a list of all categories in the Totalcmd.inc file.

Added New shortcut Ctrl+E for Export To Main Menu on File menu.

Version 5.12 --- 4 September, 2005

Added New button "Clear List" added to Find dialog box.

Added Support using variable path "utceditors:\" instead of the program real path.

Added Press 'Esc' key to close Find dialog box.

Fixed Export to Main Menu file reminder message wasn't popup when using default language.

Version 5.10 --- 20 June, 2005

Added New function "Export to Main Menu file".

Added New function "Find".

Added Save commands under wincmd.ini [Shortcuts] section as text, decimal or hexadecimal.

Added Adding predefined font list to "Export to clipboard" dialog box.

Added "Export to clipboard" dialog box becomes modeless. (useful to return to the main window and re-arrange columns).

Added New setting key added to the program section in the file "ultra tc editors.ini": CommandListFullRowSelect.

Fixed Error occur very rarely if a key pressed while startup.

Fixed Choose font dialog box wasn't pre-select current font size.

Fixed Some corrections in the program data file "tc default hotkeys.hky".

Version 5.02 --- 10 April, 2005

Added Total Commander internal command code column added.

Added New option "Add Separator" added to Export to Clipboard dialog box.

Added New option "Command List" added to Export to Clipboard dialog box.

Added Columns exported to the Clipboard in the same sequence they appear in the program.

Added Program settings file "ultra tc editors.ini" path and name can be customized.

Fixed The program always terminated at startup if it closed while the command list was sorted by "User-defined Hotkey".

Fixed When open a file, the content of "User-defined Hotkey" column was appended.

Fixed Error in "tc default hotkeys.hky" file,132=Alt + F2 corrected to 231=Alt + F2.

Version 5.01 --- 28 March, 2005

Added Ability to build hotkey in reverse order (e.g. F5 + Ctrl + Shift).

Added New option for "Reverse order hotkeys" feature.

Added Add "Num" prefix to "/", "*", "-" or "+" if they exist in the opened file.

Added The program remember last sort order and last sorted column.

Fixed Default Wincmd.ini file always added at the top of recent files list.

Fixed Always ask for default hotkeys data file at startup if this file was not found.

Fixed In rare case "Subscript out of range" error occurs at startup.

Fixed Clipboard was cleared even when the user cancel "Export to Clipboard" dialog box.

Version 5.00 --- 15 March, 2005

Added Recognize Total Commander start menu shortcuts.

Added New function "Export to Clipboard" (useful if you want to print hotkeys list).

Fixed Minor bugs fixed.

Changed The program become one of Ultra TC Editors 5 package.

Version 1.03 --- 23 November, 2004

Added Use arrow keys to select an item from 'complete keys list' then press Enter or Space.

Added Press Right arrow key (while drop-down list has focus) to show 'complete keys list'.

Added Press Escape to hide 'complete keys list' if it is visible.

Added Press Escape to clear Ctrl, Alt, Shift and key selection.

Fixed Error occur if Alt key pressed while Alt checkbox is disabled.

Fixed Minor bugs fixed.

Version 1.02 --- 19 November, 2004

Added New option "Use ContextMenu key instead of Alt key."

Added Press Backspace to clear Ctrl, Alt, Shift and key selection.

Added Recent files list.

Added New function 'Delete All Hotkeys'

Version 1.01 --- 12 November, 2004

Added Support using system environment variable in registry value that refer to Wincmd.ini location.

Fixed Error occur if the program didn't found Wincmd.ini automatically.

Fixed minor bugs fixed.

Changed Press 'context menu key beside right Ctrl' or 'Alt + A' instead of 'Alt' because pressing Alt activate the program menu bar

Version 1.00 --- 8 November, 2004

  • First release.


Add new data key

Add new data key dialog box

Notes:

  • When the cursor is inside the description field, press F2 or Ctrl+Enter to close the dialog and apply changes.
  • The section drop down list doesn't contain sections like Searches, Extensions, PackerPlugin, User, DirMenu, Connections, OldConnections etc..., because the program reads the entire contents of these sections and there is not any individual key that can be stored in the data file.
  • The contents of the section drop down list will vary according to the specified file Wincmd.ini or Wcx_ftp.ini.
  • For details about each option in this dialog, please read the description of the data file key element.


Modify data key

Modify data key dialog box

Notes:

  • When the cursor is inside the description field, press F2 or Ctrl+Enter to close the dialog and apply changes.
  • The section drop down list doesn't contain sections like Searches, Extensions, PackerPlugin, User, DirMenu, Connections, OldConnections etc..., because the program reads the entire contents of these sections and there is not any individual key that can be stored in the data file.
  • The contents of the section drop down list will vary according to the specified file Wincmd.ini or Wcx_ftp.ini.
  • For details about each option in this dialog, please read the description of the data file key element.


Command Alias

Command Alias is a fast way to execute internal or external command via Total Commander's command line.

How to use command alias:

  1. Run Ultra TC Hotkey Editor
  2. Select any internal or external command e.g. cm_ExecuteDOS
  3. Press Ctrl+Tab to switch to the Alias mode (if it is not the active mode)
  4. Type your desired alias for that command e.g. dos and press Enter key
  5. Press Ctrl+Q to save and restart Total Commander
  6. After Total Commander starts type dos in the command line and press Enter key to quickly open MS-DOS command prompt window


Total Commander Directory Menu

Also known as Directory hotlist, it is allows to quickly switch between multiple directories. The directory menu can be opened in three different ways:

  1. By pressing the default hotkey Ctrl+D
  2. By clicking on the star button Star button
  3. By double clicking on the title bar of the file windows (display of the current path).

Total Commander Directory Menu


Total Commander Extended Commands

Extended command is another way to start your favorite applications, it is similar to start menu command but the main advantage of extended command over start menu command is ability to using it directly in Total Commander main menu, toolbar or assign hotkey to it without adding it to Totalcmd.inc file.


Total Commander Main Menu

Total Commander Main Menu


Total Commander Start Menu

Overview

You can place your favorite applications in the start menu.

The main advantage of starting an application from Total Commander start menu is ability to pass the current directory and/or the file under the cursor to this application.

Total Commander Start Menu

Start Menu position

By defaut the start menu comes after Configuration menu, this default position can be changed as follows:

  1. Run Ultra TC Main Menu Editor.
  2. If the item STARTMENU not exists, press Ctrl+J to add it.
  3. Select STARTMENU item and move it to any desired position. (you can even place it inside a submenu!)
  4. Press Ctrl+Q to save and restart Total Commander.


Customize Toolbar

Customize toolbar dialog box

Options:

check box Default

Switches between the default toolbar and the customized toolbar.

Buttons:

  • toolbar icon Moves the selected button one place up. (shortcut Ctrl+Up)
  • toolbar icon Moves the selected button one place down. (shortcut Ctrl+Down)
  • toolbar icon Adds a separator just under the selected button. (shortcut Ctrl+L)
  • toolbar icon Hides the selected button if it is a normal button and deletes it if it is a separator. (shortcut Del)
  • OK: closes the dialog box and saves any changes you have made.
  • Cancel: closes the dialog box without saving any changes you have made.

Notes:

  • To show/hide a button, double click on it or press <Space> key.
  • To use your won icons, download this icon library sample and replace the icons inside it with your won icons then put it inside Ultra TC Editors folder.
    To save the icon library in different place, add ToolbarIconLib=path\of\ultra tc editors.icl under [Common] section in "ultra tc editors.ini".
  • Above screen shoot shows the customize toolbar dialog for the Main Menu Editor, but all above notes are applying to customize toolbar dialog in all other Ultra TC Editors programs.